/* Driver template for the LEMON parser generator.
** The author disclaims copyright to this source code.
*/
/* First off, code is include which follows the "include" declaration
** in the input file. */
#include <stdio.h>
#line 33 "parse.y"

#include "sqliteInt.h"
#include "parse.h"

/*
** An instance of this structure holds information about the
** LIMIT clause of a SELECT statement.
*/
struct LimitVal {
  int limit;    /* The LIMIT value.  -1 if there is no limit */
  int offset;   /* The OFFSET.  0 if there is none */
};

/*
** An instance of the following structure describes the event of a
** TRIGGER.  "a" is the event type, one of TK_UPDATE, TK_INSERT,
** TK_DELETE, or TK_INSTEAD.  If the event is of the form
**
**      UPDATE ON (a,b,c)
**
** Then the "b" IdList records the list "a,b,c".
*/
struct TrigEvent { int a; IdList * b; };


#line 34 "parse.c"
/* Next is all token values, in a form suitable for use by makeheaders.
** This section will be null unless lemon is run with the -m switch.
*/
/* 
** These constants (all generated automatically by the parser generator)
** specify the various kinds of tokens (terminals) that the parser
** understands. 
**
** Each symbol here is a terminal symbol in the grammar.
*/
/* Make sure the INTERFACE macro is defined.
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/* The next thing included is series of defines which control
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 terminals
**                       and nonterminals.  "int" is used otherwise.
**    YYNOCODE           is a number of type YYCODETYPE which corresponds
**                       to no legal terminal or nonterminal number.  This
**                       number is used to fill in empty slots of the hash 
**                       table.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       have fall-back values which should be used if the
**                       original value of the token will not parse.
**    YYACTIONTYPE       is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 rules and
**                       states combined.  "int" is used otherwise.
**    sqlite3ParserTOKENTYPE     is the data type used for minor tokens given 
**                       directly to the parser from the tokenizer.
**    YYMINORTYPE        is the data type used for all minor tokens.
**                       This is typically a union of many types, one of
**                       which is sqlite3ParserTOKENTYPE.  The entry in the union
**                       for base tokens is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.
**    sqlite3ParserARG_SDECL     A static variable declaration for the %extra_argument
**    sqlite3ParserARG_PDECL     A parameter declaration for the %extra_argument
**    sqlite3ParserARG_STORE     Code to store %extra_argument into yypParser
**    sqlite3ParserARG_FETCH     Code to extract %extra_argument from yypParser
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
*/
/*  */
#define YYCODETYPE unsigned char
#define YYNOCODE 220
#define YYACTIONTYPE unsigned short int
#define sqlite3ParserTOKENTYPE Token
typedef union {
  sqlite3ParserTOKENTYPE yy0;
  struct LimitVal yy22;
  Expr* yy164;
  Expr * yy206;
  ExprList* yy232;
  IdList* yy246;
  SrcList* yy283;
  struct {int value; int mask;} yy299;
  Token yy318;
  TriggerStep * yy353;
  Select* yy375;
  struct TrigEvent yy414;
  int yy424;
  int yy439;
} YYMINORTYPE;
#define YYSTACKDEPTH 100
#define sqlite3ParserARG_SDECL Parse *pParse;
#define sqlite3ParserARG_PDECL ,Parse *pParse
#define sqlite3ParserARG_FETCH Parse *pParse = yypParser->pParse
#define sqlite3ParserARG_STORE yypParser->pParse = pParse
#define YYNSTATE 564
#define YYNRULE 292
#define YYERRORSYMBOL 130
#define YYERRSYMDT yy439
#define YYFALLBACK 1
#define YY_NO_ACTION      (YYNSTATE+YYNRULE+2)
#define YY_ACCEPT_ACTION  (YYNSTATE+YYNRULE+1)
#define YY_ERROR_ACTION   (YYNSTATE+YYNRULE)

/* Next are that tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N < YYNSTATE                  Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   YYNSTATE <= N < YYNSTATE+YYNRULE   Reduce by rule N-YYNSTATE.
**
**   N == YYNSTATE+YYNRULE              A syntax error has occurred.
**
**   N == YYNSTATE+YYNRULE+1            The parser accepts its input.
**
**   N == YYNSTATE+YYNRULE+2            No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as
**
**      yy_action[ yy_shift_ofst[S] + X ]
**
** If the index value yy_shift_ofst[S]+X is out of range or if the value
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X or if yy_shift_ofst[S]
** is equal to YY_SHIFT_USE_DFLT, it means that the action is not in the table
** and that yy_default[S] should be used instead.  
**
** The formula above is for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array and YY_REDUCE_USE_DFLT is used in place of
** YY_SHIFT_USE_DFLT.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
*/
static YYACTIONTYPE yy_action[] = {
 /*     0 */   264,  836,  262,  119,  123,  117,  121,  129,  131,  133,
 /*    10 */   135,  144,  146,  148,  150,  152,  154,  429,  143,  857,
 /*    20 */     1,  563,    3,  142,  129,  131,  133,  135,  144,  146,
 /*    30 */   148,  150,  152,  154,  314,  321,  323,  115,  103,  139,
 /*    40 */   127,  125,  156,  161,  157,  162,  166,  119,  123,  117,
 /*    50 */   121,  129,  131,  133,  135,  144,  146,  148,  150,  152,
 /*    60 */   154,  344,   29,  143,  263,  362,  354,  831,  142,  144,
 /*    70 */   146,  148,  150,  152,  154,   34,   67,   45,  561,  562,
 /*    80 */    63,  336,  115,  103,  139,  127,  125,  156,  161,  157,
 /*    90 */   162,  166,  119,  123,  117,  121,  129,  131,  133,  135,
 /*   100 */   144,  146,  148,  150,  152,  154,  382,  193,   35,   53,
 /*   110 */    59,   61,  306,  337,  346,  349,  420,  175,  363,  339,
 /*   120 */   105,   11,  640,  343,   26,  345,   27,   28,  352,  353,
 /*   130 */   296,   57,  143,  181,  179,  301,  641,  142,  365,   58,
 /*   140 */   174,  177,   65,   66,  110,  364,  396,  111,  104,  137,
 /*   150 */   794,  115,  103,  139,  127,  125,  156,  161,  157,  162,
 /*   160 */   166,  119,  123,  117,  121,  129,  131,  133,  135,  144,
 /*   170 */   146,  148,  150,  152,  154,  105,  299,  792,  564,  574,
 /*   180 */   112,  113,  183,   12,   13,  219,  367,  561,  562,  363,
 /*   190 */   369,  375,  380,   11,   23,  303,  167,  397,   28,    5,
 /*   200 */    11,  383,  143,   22,  367,  398,  173,  142,  369,  375,
 /*   210 */   380,  148,  150,  152,  154,  169,  584,  171,  172,  383,
 /*   220 */   191,  115,  103,  139,  127,  125,  156,  161,  157,  162,
 /*   230 */   166,  119,  123,  117,  121,  129,  131,  133,  135,  144,
 /*   240 */   146,  148,  150,  152,  154,  367,   11,  143,  569,  369,
 /*   250 */   375,  380,  142,    2,    3,   12,   13,   31,  341,  262,
 /*   260 */   383,   67,   12,   13,  336,   63,  115,  103,  139,  127,
 /*   270 */   125,  156,  161,  157,  162,  166,  119,  123,  117,  121,
 /*   280 */   129,  131,  133,  135,  144,  146,  148,  150,  152,  154,
 /*   290 */   319,  169,  193,  171,  172,   83,   85,  839,  298,  545,
 /*   300 */   543,  232,  175,   64,  691,  105,   82,  230,   12,   13,
 /*   310 */   105,   11,  169,  320,  171,  172,  793,  143,  181,  179,
 /*   320 */   536,  263,  142,   51,  401,  174,  177,   65,   66,  110,
 /*   330 */   102,   52,  111,  104,  455,  213,  115,  103,  139,  127,
 /*   340 */   125,  156,  161,  157,  162,  166,  119,  123,  117,  121,
 /*   350 */   129,  131,  133,  135,  144,  146,  148,  150,  152,  154,
 /*   360 */   304,  244,  316,   94,  237,  112,  113,  183,  795,  197,
 /*   370 */   219,  450,  279,   12,   13,  311,   11,    8,  201,  143,
 /*   380 */   662,  489,  461,  451,  142,  689,  169,  436,  171,  172,
 /*   390 */   392,  205,   72,  448,  195,  592,  221,   68,  115,  103,
 /*   400 */   139,  127,  125,  156,  161,  157,  162,  166,  119,  123,
 /*   410 */   117,  121,  129,  131,  133,  135,  144,  146,  148,  150,
 /*   420 */   152,  154,  474,  264,  143,  262,  572,  313,  189,  142,
 /*   430 */   209,  295,  339,  394,  310,  294,   10,  456,   12,   13,
 /*   440 */   393,  837,  458,  115,  103,  139,  127,  125,  156,  161,
 /*   450 */   157,  162,  166,  119,  123,  117,  121,  129,  131,  133,
 /*   460 */   135,  144,  146,  148,  150,  152,  154,  844,   11,  143,
 /*   470 */   169,  842,  171,  172,  142,  664,  169,  575,  171,  172,
 /*   480 */   402,  573,   37,  318,    9,  317,  280,  263,  115,  103,
 /*   490 */   139,  127,  125,  156,  161,  157,  162,  166,  119,  123,
 /*   500 */   117,  121,  129,  131,  133,  135,  144,  146,  148,  150,
 /*   510 */   152,  154,   68,   11,  143,  727,  816,   46,  410,  142,
 /*   520 */   405,  426,  428,  427,  281,  259,  546,  247,   48,  282,
 /*   530 */    12,   13,  691,  115,  103,  139,  127,  125,  156,  161,
 /*   540 */   157,  162,  166,  119,  123,  117,  121,  129,  131,  133,
 /*   550 */   135,  144,  146,  148,  150,  152,  154,   11,  254,  143,
 /*   560 */   216,   15,  217,  169,  142,  171,  172,  169,  534,  171,
 /*   570 */   172,  169,  576,  171,  172,   12,   13,   17,  115,  164,
 /*   580 */   139,  127,  125,  156,  161,  157,  162,  166,  119,  123,
 /*   590 */   117,  121,  129,  131,  133,  135,  144,  146,  148,  150,
 /*   600 */   152,  154,   11,  256,  143,  249,  259,  170,   74,  142,
 /*   610 */   667,  169,  293,  171,  172,  287,  234,  248,  217,   12,
 /*   620 */    13,  266,  221,  115,  227,  139,  127,  125,  156,  161,
 /*   630 */   157,  162,  166,  119,  123,  117,  121,  129,  131,  133,
 /*   640 */   135,  144,  146,  148,  150,  152,  154,  105,  105,  143,
 /*   650 */   276,  273,  267,  274,  142,  300,  577,  217,  494,  311,
 /*   660 */   327,   19,  328,  347,   12,   13,  348,  102,  174,  103,
 /*   670 */   139,  127,  125,  156,  161,  157,  162,  166,  119,  123,
 /*   680 */   117,  121,  129,  131,  133,  135,  144,  146,  148,  150,
 /*   690 */   152,  154,  105,  690,  143,  251,  503,  251,  497,  142,
 /*   700 */   355,   96,  272,  578,  262,  579,   67,  266,  159,   21,
 /*   710 */    63,  313,  184,  218,   24,  139,  127,  125,  156,  161,
 /*   720 */   157,  162,  166,  119,  123,  117,  121,  129,  131,  133,
 /*   730 */   135,  144,  146,  148,  150,  152,  154,  193,  289,  158,
 /*   740 */     4,    6,  432,   90,   20,  431,  350,  175,   67,  351,
 /*   750 */   506,  332,   63,  583,  185,  137,  357,  143,  358,  253,
 /*   760 */   433,  253,  142,  181,  179,  535,  263,  809,  266,   88,
 /*   770 */   500,  177,   65,   66,  110,  105,   68,  111,  104,  193,
 /*   780 */   326,   11,  168,  435,  225,  229,  252,  721,  252,  175,
 /*   790 */   276,  373,  378,  328,  328,  174,   72,  274,   67,  284,
 /*   800 */   466,  519,   63,  424,  425,  181,  179,  290,   68,  224,
 /*   810 */   112,  113,  183,  177,   65,   66,  110,  105,  333,  111,
 /*   820 */   104,  105,    7,   40,   14,   16,   18,  400,  332,  193,
 /*   830 */   332,  215,   41,  537,  538,  539,   37,  488,  549,  175,
 /*   840 */   219,  114,  430,   12,   13,   42,  558,   30,   43,  387,
 /*   850 */    45,  328,  112,  113,  183,  181,  179,  372,  447,   44,
 /*   860 */   531,  450,  455,  177,   65,   66,  110,  529,  105,  111,
 /*   870 */   104,  332,  832,  105,   38,  231,  332,  484,   32,  342,
 /*   880 */    69,   35,   53,   59,   61,  306,  337,   68,  174,  332,
 /*   890 */   399,  409,  339,  297,  802,  333,   25,  329,  245,  105,
 /*   900 */   377,   68,  112,  113,  183,  386,   68,   33,  105,  507,
 /*   910 */   512,  451,  474,  481,  105,  493,   68,   68,  444,  488,
 /*   920 */    72,  105,  105,  276,  233,  105,  105,  460,  116,  445,
 /*   930 */   721,  328,  458,  219,  118,  105,  652,  105,  333,   68,
 /*   940 */   105,  120,  122,  333,  105,  124,  126,  105,  105,  691,
 /*   950 */   105,  105,  105,  105,  105,  128,  333,  130,  105,  527,
 /*   960 */   132,  105,  105,  105,  134,  105,  105,  136,  138,  452,
 /*   970 */   141,  145,  147,  149,  151,  478,  105,  105,  153,  105,
 /*   980 */   105,  155,  163,  165,  105,  176,  178,  105,  105,  105,
 /*   990 */   471,  105,  105,  105,  105,  105,  180,  182,  291,  190,
 /*  1000 */   192,  105,  691,  105,  210,  105,  471,  212,  421,  214,
 /*  1010 */   105,  226,  228,  241,  246,  278,  221,  479,  288,  274,
 /*  1020 */   852,  381,   72,  469,   37,  473,  487,  691,  485,   72,
 /*  1030 */   486,  524,  654,   36,  528,  482,  485,  221,   47,   39,
 /*  1040 */   541,  245,  525,  542,   50,   49,   54,  465,   55,   56,
 /*  1050 */    60,  221,   62,  593,  594,   70,   72,   68,   71,   75,
 /*  1060 */    81,   73,  242,  517,  245,   76,  240,   77,   87,   92,
 /*  1070 */    78,   84,   86,   93,   79,   89,   80,   91,   95,   99,
 /*  1080 */    98,  100,  101,  106,  137,  108,  154,  107,  109,  160,
 /*  1090 */    97,  668,  211,  220,  188,  669,  670,  140,  194,  198,
 /*  1100 */   186,  196,  187,  199,  200,  202,  203,  204,  206,  207,
 /*  1110 */   208,  223,  221,  222,  235,  236,  239,  217,  238,  243,
 /*  1120 */   250,  258,  261,  277,  268,  555,  255,  257,  260,  265,
 /*  1130 */   270,  271,  275,  269,  283,  292,  302,  285,  325,  286,
 /*  1140 */   308,  310,  307,  360,  395,  312,  370,  371,  305,  330,
 /*  1150 */   376,  334,  384,  309,  385,  388,   48,  408,  315,  322,
 /*  1160 */   368,  415,  324,  338,  422,  389,  331,  335,  361,  403,
 /*  1170 */   404,  356,  359,  406,  407,  411,  340,  374,  412,  379,
 /*  1180 */   391,  366,  413,  416,  390,  417,  824,  423,  829,  830,
 /*  1190 */   414,  434,  437,  438,  439,  440,  443,  441,  446,  442,
 /*  1200 */   800,  801,  457,  449,  453,  823,  728,  454,  459,  729,
 /*  1210 */   452,  838,  463,  462,  464,  470,  467,  468,  840,  472,
 /*  1220 */   475,  477,  483,  841,  492,  843,  661,  476,  663,  490,
 /*  1230 */   808,  491,  495,  849,  508,  498,  720,  480,  496,  501,
 /*  1240 */   513,  504,  511,  418,  499,  419,  502,  505,  509,  510,
 /*  1250 */   515,  516,  518,  514,  723,  520,  521,  526,  523,  726,
 /*  1260 */   810,  811,  522,  530,  812,  532,  533,  813,  814,  817,
 /*  1270 */   819,  540,  820,  818,  544,  547,  548,  815,  557,  553,
 /*  1280 */   551,  850,  851,  552,  550,  560,  554,  559,  855,  556,
};
static YYCODETYPE yy_lookahead[] = {
 /*     0 */    21,   11,   23,   68,   69,   70,   71,   72,   73,   74,
 /*    10 */    75,   76,   77,   78,   79,   80,   81,   47,   39,  131,
 /*    20 */   132,  133,  134,   44,   72,   73,   74,   75,   76,   77,
 /*    30 */    78,   79,   80,   81,   98,   99,  100,   58,   59,   60,
 /*    40 */    61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
 /*    50 */    71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
 /*    60 */    81,   23,  148,   39,   85,  151,  152,   97,   44,   76,
 /*    70 */    77,   78,   79,   80,   81,  155,   19,   60,    9,   10,
 /*    80 */    23,  161,   58,   59,   60,   61,   62,   63,   64,   65,
 /*    90 */    66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
 /*   100 */    76,   77,   78,   79,   80,   81,  156,   50,   91,   92,
 /*   110 */    93,   94,   95,   96,   76,   77,  126,   60,  138,  102,
 /*   120 */   138,   23,   20,   85,   22,   87,  146,  147,   90,   91,
 /*   130 */    20,   26,   39,   76,   77,   78,   20,   44,   22,   34,
 /*   140 */   158,   84,   85,   86,   87,  165,  166,   90,   91,  199,
 /*   150 */   126,   58,   59,   60,   61,   62,   63,   64,   65,   66,
 /*   160 */    67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
 /*   170 */    77,   78,   79,   80,   81,  138,  194,   14,    0,    9,
 /*   180 */   123,  124,  125,   85,   86,  203,   88,    9,   10,  138,
 /*   190 */    92,   93,   94,   23,  143,  158,   19,  146,  147,    9,
 /*   200 */    23,  103,   39,   19,   88,   21,   20,   44,   92,   93,
 /*   210 */    94,   78,   79,   80,   81,  105,    9,  107,  108,  103,
 /*   220 */   127,   58,   59,   60,   61,   62,   63,   64,   65,   66,
 /*   230 */    67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
 /*   240 */    77,   78,   79,   80,   81,   88,   23,   39,    9,   92,
 /*   250 */    93,   94,   44,  133,  134,   85,   86,  154,  155,   23,
 /*   260 */   103,   19,   85,   86,  161,   23,   58,   59,   60,   61,
 /*   270 */    62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
 /*   280 */    72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
 /*   290 */    29,  105,   50,  107,  108,   76,   77,   14,   20,   76,
 /*   300 */    77,   20,   60,   19,   19,  138,   87,   19,   85,   86,
 /*   310 */   138,   23,  105,   52,  107,  108,   14,   39,   76,   77,
 /*   320 */    97,   85,   44,   33,  141,  158,   84,   85,   86,   87,
 /*   330 */   158,   41,   90,   91,   51,  127,   58,   59,   60,   61,
 /*   340 */    62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
 /*   350 */    72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
 /*   360 */    20,  194,  101,  191,  192,  123,  124,  125,  126,   15,
 /*   370 */   203,  145,   19,   85,   86,   45,   23,  137,   24,   39,
 /*   380 */     9,   98,   99,  100,   44,   20,  105,  204,  107,  108,
 /*   390 */    60,   37,  109,  210,   40,  111,  111,  171,   58,   59,
 /*   400 */    60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
 /*   410 */    70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
 /*   420 */    80,   81,  196,   21,   39,   23,    9,   97,  126,   44,
 /*   430 */   128,  106,  102,  161,  162,  110,  138,  211,   85,   86,
 /*   440 */   168,   11,  216,   58,   59,   60,   61,   62,   63,   64,
 /*   450 */    65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
 /*   460 */    75,   76,   77,   78,   79,   80,   81,    9,   23,   39,
 /*   470 */   105,    9,  107,  108,   44,    9,  105,    9,  107,  108,
 /*   480 */    17,    9,   97,   89,   12,   91,  145,   85,   58,   59,
 /*   490 */    60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
 /*   500 */    70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
 /*   510 */    80,   81,  171,   23,   39,    9,    9,   91,   55,   44,
 /*   520 */    57,   98,   99,  100,  183,  184,   19,   22,  102,  188,
 /*   530 */    85,   86,   21,   58,   59,   60,   61,   62,   63,   64,
 /*   540 */    65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
 /*   550 */    75,   76,   77,   78,   79,   80,   81,   23,  113,   39,
 /*   560 */    20,  137,   22,  105,   44,  107,  108,  105,   61,  107,
 /*   570 */   108,  105,    9,  107,  108,   85,   86,  137,   58,   59,
 /*   580 */    60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
 /*   590 */    70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
 /*   600 */    80,   81,   23,  113,   39,  183,  184,  106,  174,   44,
 /*   610 */   109,  105,   78,  107,  108,  181,   20,  112,   22,   85,
 /*   620 */    86,  151,  111,   58,   59,   60,   61,   62,   63,   64,
 /*   630 */    65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
 /*   640 */    75,   76,   77,   78,   79,   80,   81,  138,  138,   39,
 /*   650 */   138,   20,  182,   22,   44,   20,    9,   22,   17,   45,
 /*   660 */    20,  137,   22,   87,   85,   86,   90,  158,  158,   59,
 /*   670 */    60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
 /*   680 */    70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
 /*   690 */    80,   81,  138,   20,   39,   22,   55,   22,   57,   44,
 /*   700 */    19,  192,  190,    9,   23,    9,   19,  151,   60,  140,
 /*   710 */    23,   97,  158,  203,  144,   60,   61,   62,   63,   64,
 /*   720 */    65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
 /*   730 */    75,   76,   77,   78,   79,   80,   81,   50,  182,   91,
 /*   740 */   135,  136,   25,   22,  139,   28,   87,   60,   19,   90,
 /*   750 */   145,  138,   23,    9,  200,  199,   20,   39,   22,   86,
 /*   760 */    43,   86,   44,   76,   77,  138,   85,    9,  151,   48,
 /*   770 */   129,   84,   85,   86,   87,  138,  171,   90,   91,   50,
 /*   780 */   167,   23,  145,   18,   66,   67,  113,    9,  113,   60,
 /*   790 */   138,   20,   20,   22,   22,  158,  109,   22,   19,  182,
 /*   800 */    22,  196,   23,   53,   54,   76,   77,   78,  171,   91,
 /*   810 */   123,  124,  125,   84,   85,   86,   87,  138,  205,   90,
 /*   820 */    91,  138,   11,   15,   13,   14,   15,   16,  138,   50,
 /*   830 */   138,  194,   24,  206,  207,  208,   97,  158,   27,   60,
 /*   840 */   203,  158,  190,   85,   86,   37,   35,  149,   40,   20,
 /*   850 */    60,   22,  123,  124,  125,   76,   77,  167,   93,   51,
 /*   860 */    49,  145,   51,   84,   85,   86,   87,   56,  138,   90,
 /*   870 */    91,  138,   97,  138,   31,  145,  138,  198,   88,   89,
 /*   880 */   145,   91,   92,   93,   94,   95,   96,  171,  158,  138,
 /*   890 */   145,  145,  102,  158,  129,  205,   20,  205,  120,  138,
 /*   900 */   167,  171,  123,  124,  125,  167,  171,  138,  138,   98,
 /*   910 */    99,  100,  196,  145,  138,  104,  171,  171,  167,  158,
 /*   920 */   109,  138,  138,  138,  194,  138,  138,  211,  158,   20,
 /*   930 */     9,   22,  216,  203,  158,  138,    9,  138,  205,  171,
 /*   940 */   138,  158,  158,  205,  138,  158,  158,  138,  138,    9,
 /*   950 */   138,  138,  138,  138,  138,  158,  205,  158,  138,  198,
 /*   960 */   158,  138,  138,  138,  158,  138,  138,  158,  158,   58,
 /*   970 */   158,  158,  158,  158,  158,  190,  138,  138,  158,  138,
 /*   980 */   138,  158,  158,  158,  138,  158,  158,  138,  138,  138,
 /*   990 */   138,  138,  138,  138,  138,  138,  158,  158,  138,  158,
 /*  1000 */   158,  138,   97,  138,  158,  138,  138,  158,  158,  158,
 /*  1010 */   138,  158,  158,  158,  158,  158,  111,   20,  158,   22,
 /*  1020 */     9,  158,  109,  158,   97,  158,   20,  101,   22,  109,
 /*  1030 */   158,  145,  121,  156,   20,  122,   22,  111,  156,  170,
 /*  1040 */    87,  120,  122,   90,   42,  164,   46,  195,  157,  156,
 /*  1050 */   156,  111,   19,  111,  111,  172,  109,  171,  171,  175,
 /*  1060 */   119,  173,  117,  195,  120,  176,  118,  177,  153,  115,
 /*  1070 */   178,   87,   87,  116,  179,  153,  180,  153,   22,   96,
 /*  1080 */   157,   23,  150,  111,  199,  111,   81,  138,  138,   91,
 /*  1090 */   193,  109,  126,  138,   14,  109,  109,  199,   19,   22,
 /*  1100 */   201,   20,  202,  138,   20,   22,  138,   20,   22,  138,
 /*  1110 */    20,  142,  111,  138,  138,  142,  157,   22,  193,  116,
 /*  1120 */   185,  113,  142,   97,  186,  114,  138,  138,  138,  138,
 /*  1130 */   114,   19,  138,  187,   20,  111,   20,  186,   19,  187,
 /*  1140 */   159,  162,  138,   20,  166,  138,   46,   19,  156,  193,
 /*  1150 */    19,  193,   46,  160,   19,   95,  102,   21,  163,  163,
 /*  1160 */   138,   97,  163,  150,   38,  138,  157,  157,  151,  138,
 /*  1170 */   142,  153,  153,  138,  142,  138,  164,  156,  142,  156,
 /*  1180 */   160,  166,  212,  138,  159,  142,   11,   36,   97,   97,
 /*  1190 */   213,   47,  129,  138,  142,   97,   19,  138,  156,  142,
 /*  1200 */     9,  129,   14,   11,  170,    9,  121,  169,    9,  121,
 /*  1210 */    58,   14,  138,  169,  101,  176,  138,   61,    9,   61,
 /*  1220 */   121,   19,   19,    9,  176,    9,    9,  138,    9,  112,
 /*  1230 */     9,  138,  138,    9,  112,  138,    9,  197,  142,  138,
 /*  1240 */   169,  138,  176,  214,  142,  215,  142,  142,  138,  142,
 /*  1250 */   142,  101,  176,  138,    9,  121,  138,   19,  197,    9,
 /*  1260 */     9,    9,  142,  138,    9,  138,  142,    9,    9,    9,
 /*  1270 */     9,  209,    9,    9,  209,  138,   20,    9,   32,  138,
 /*  1280 */   151,    9,    9,   21,  217,  138,  218,  217,    9,  151,
};
#define YY_SHIFT_USE_DFLT (-66)
static short yy_shift_ofst[] = {
 /*     0 */    69,  178,  -66,  811,  190,  -66,  239,  472,  417,  170,
 /*    10 */   468,  -66,  -66,  -66,  472,  563,  472,  647,  472,  694,
 /*    20 */   184,  696,  579,  102,  876,  744,   98,  -66,  236,  -66,
 /*    30 */   790,  -66,  579,   17,  -66,  739,  -66,  843,  808,  -66,
 /*    40 */   -66,  -66,  -66,  -66,  -66,  426,  739,  -66, 1002,  -66,
 /*    50 */   290,  -66,  -66, 1000,  105,  739,  -66,  -66,  -66,  739,
 /*    60 */   -66, 1033,  779,  284,   57,  942,  943,  687,  -66,  110,
 /*    70 */   947,  -66,  325,  -66,  505,  944,  945,  948,  954,  941,
 /*    80 */   -66,  219,  -66,  984,  -66,  985,  -66,  721,  219,  -66,
 /*    90 */   219,  -66,  957,  779, 1056,  779,  983,  105,  -66, 1058,
 /*   100 */   -66,  -66,  475,  779,  -66,  972,  579,  974,  579,  -66,
 /*   110 */   -66,  -66,  -66,  -66,  655,  779,  610,  779,  -48,  779,
 /*   120 */   -48,  779,  -48,  779,  -48,  779,  -65,  779,  -65,  779,
 /*   130 */    -7,  779,   -7,  779,   -7,  779,   -7,  779,  -65,  718,
 /*   140 */   779,  -65,  -66,  -66,  779,  133,  779,  133,  779, 1005,
 /*   150 */   779, 1005,  779, 1005,  779,  -66,  -66,  648,  -66,  998,
 /*   160 */   -66,  -66,  779,  520,  779,  -65,  177,  687,  186,  501,
 /*   170 */   982,  986,  987,  -66,  475,  779,  655,  779,  -66,  779,
 /*   180 */   -66,  779,  -66,  242,   24,  966,  302, 1080,  -66,  779,
 /*   190 */    93,  779,  475, 1079,  354, 1081,  -66, 1077,  579, 1084,
 /*   200 */   -66, 1083,  579, 1087,  -66, 1086,  579, 1090,  -66,  779,
 /*   210 */   163,  779,  208,  779,  475,  540,  -66,  779,  -66,  -66,
 /*   220 */  1001,  579,  -66,  -66,  -66,  779,  565,  779,  655,  288,
 /*   230 */   687,  281,  -66,  596,  -66, 1001,  -66,  983,  105,  -66,
 /*   240 */   779,  475, 1003,  779, 1095,  779,  475,  -66,  -66,  675,
 /*   250 */   -66,  -66,  -66,  445,  -66,  490,  -66, 1008,  -66,  353,
 /*   260 */  1001,  402,  -66,  -66,  579,  -66,  -66, 1026, 1016,  -66,
 /*   270 */  1112,  579,  631,  -66,  579,  -66,  -66,  779,  475,  947,
 /*   280 */   365,  673, 1114,  402, 1026, 1016,  -66,  729,  -21,  -66,
 /*   290 */   -66, 1024,  534,  -66,  -66,  -66,  -66,  278,  -66,  635,
 /*   300 */   -66, 1116,  -66,  340,  739,  -66,  579, 1119,  -66,  614,
 /*   310 */   -66,  579,  -66,  -64,  261,  -66,  394,  -66,  -66,  -66,
 /*   320 */   -66,  261,  -66,  261,  -66,  579,  640,  -66,  579,  983,
 /*   330 */   105,  -66,  -66,  983,  105,  -66,  -66, 1058,  -66, 1002,
 /*   340 */   -66,  -66,   38,  -66,  -66,  -66,  576,  -66,  -66,  659,
 /*   350 */   -66,  -66,  -66,  -66,  681,  219,  736,  -66,  219, 1123,
 /*   360 */   -66,  -66,  -66,  -66,  116,  157,  -66,  579,  -66, 1100,
 /*   370 */  1128,  579,  771,  739,  -66, 1131,  579,  772,  739,  -66,
 /*   380 */   779,  385,  -66, 1106, 1135,  579,  829, 1060,  579, 1119,
 /*   390 */   -66,  330, 1054,  -66,  -66,  -66,  -66,  -66,  947,  207,
 /*   400 */   765,  463,  579, 1001,  -66,  579,  511, 1136,  947,  371,
 /*   410 */   579, 1001,  717,  423, 1064,  579, 1001, 1126,  -10, 1175,
 /*   420 */   779,  430, 1151,  750,  -66,  -66, 1091, 1092,  -30,  579,
 /*   430 */   775,  -66,  -66, 1144,  -66,  -66, 1063,  579,  905, 1098,
 /*   440 */   579,  285, 1177,  579,  909,  927, 1191, 1072, 1192,  283,
 /*   450 */   458,  911,  808,  -66, 1085, 1088, 1188, 1196, 1199,  283,
 /*   460 */  1197, 1152,  579, 1113,  579,  778,  579, 1156,  779,  475,
 /*   470 */  1209, 1158,  779,  475, 1099,  579, 1202,  579,  997,  -66,
 /*   480 */   913,  462, 1203,  779, 1006,  779,  475, 1214,  475, 1117,
 /*   490 */   579,  921, 1216,  641,  579,  940, 1217,  579,  940, 1219,
 /*   500 */   579,  940, 1221,  579,  940, 1224,  466, 1122,  579, 1001,
 /*   510 */   921, 1227, 1152,  579,  926, 1150,  579,  778, 1245, 1134,
 /*   520 */   579, 1001, 1202,  920,  506, 1238,  779, 1014, 1250,  758,
 /*   530 */  1251,  579, 1001,  507,  223, 1252, 1255, 1258, 1259,  953,
 /*   540 */  1260, 1261, 1263,  953, 1264,  -66,  579, 1256, 1268, 1246,
 /*   550 */   236, 1262,  579, 1011, 1272,  236, 1273,  -66, 1246,  579,
 /*   560 */  1279,  -66,  -66,  -66,
};
#define YY_REDUCE_USE_DFLT (-113)
static short yy_reduce_ofst[] = {
 /*     0 */  -112,  120, -113,  605, -113, -113, -113,  240, -113,  298,
 /*    10 */  -113, -113, -113, -113,  424, -113,  440, -113,  524, -113,
 /*    20 */   569, -113,   51,  570, -113, -113,  -20, -113,  -86,  698,
 /*    30 */   103, -113,  769,  -80, -113,  877, -113, -113,  869, -113,
 /*    40 */  -113, -113, -113, -113, -113, -113,  882, -113,  881, -113,
 /*    50 */  -113, -113, -113, -113,  891,  893, -113, -113, -113,  894,
 /*    60 */  -113, -113,   37, -113,  -18, -113, -113,  735, -113,  883,
 /*    70 */   887, -113,  888,  434,  884,  889,  890,  892,  895,  896,
 /*    80 */  -113,  915, -113, -113, -113, -113, -113, -113,  922, -113,
 /*    90 */   924, -113, -113,  172, -113,  509,  897,  923, -113,  932,
 /*   100 */  -113, -113,  885,  683, -113, -113,  949, -113,  950, -113,
 /*   110 */  -113, -113, -113, -113,  885,  770,  885,  776,  885,  783,
 /*   120 */   885,  784,  885,  787,  885,  788,  885,  797,  885,  799,
 /*   130 */   885,  802,  885,  806,  885,  809,  885,  810,  885,  898,
 /*   140 */   812,  885, -113, -113,  813,  885,  814,  885,  815,  885,
 /*   150 */   816,  885,  820,  885,  823,  885, -113, -113, -113, -113,
 /*   160 */  -113, -113,  824,  885,  825,  885,  955,  637,  883, -113,
 /*   170 */  -113, -113, -113, -113,  885,  827,  885,  828,  885,  838,
 /*   180 */   885,  839,  885,  554,  885,  899,  900, -113, -113,  841,
 /*   190 */   885,  842,  885, -113, -113, -113, -113, -113,  965, -113,
 /*   200 */  -113, -113,  968, -113, -113, -113,  971, -113, -113,  846,
 /*   210 */   885,  849,  885,  851,  885, -113, -113,  510, -113, -113,
 /*   220 */   969,  975, -113, -113, -113,  853,  885,  854,  885,  976,
 /*   230 */   730,  883, -113, -113, -113,  973, -113,  925,  959, -113,
 /*   240 */   855,  885, -113,  167, -113,  856,  885, -113,  422,  935,
 /*   250 */  -113, -113, -113,  988, -113,  989, -113, -113, -113,  990,
 /*   260 */   980,  470, -113, -113,  991, -113, -113,  938,  946, -113,
 /*   270 */  -113,  512, -113, -113,  994, -113, -113,  857,  885,  341,
 /*   280 */   883,  935, -113,  617,  951,  952, -113,  860,  556, -113,
 /*   290 */  -113, -113,  949, -113, -113, -113, -113,  885, -113, -113,
 /*   300 */  -113, -113, -113,  885,  992, -113, 1004,  981,  993,  979,
 /*   310 */  -113, 1007, -113, -113,  995, -113, -113, -113, -113, -113,
 /*   320 */  -113,  996, -113,  999, -113,  613, -113, -113,  692,  956,
 /*   330 */  1009, -113, -113,  958, 1010, -113, -113, 1013, -113, 1012,
 /*   340 */  -113, -113, -113, -113, -113, -113, -113, -113, -113, -113,
 /*   350 */  -113, -113, -113, -113, 1017, 1018, -113, -113, 1019, -113,
 /*   360 */  -113, -113, -113, -113,  978, 1015, -113, 1022, -113, -113,
 /*   370 */  -113,  690, -113, 1021, -113, -113,  733, -113, 1023, -113,
 /*   380 */   863,  -50, -113, -113, -113,  738, -113, -113, 1027, 1025,
 /*   390 */  1020,  272, -113, -113, -113, -113, -113, -113,  745,  883,
 /*   400 */   183, -113, 1031, 1028, -113, 1035, 1032, -113,  746,  883,
 /*   410 */  1037, 1036,  970,  977, -113, 1045, 1043, 1029, 1030, -113,
 /*   420 */   850,  885, -113, -113, -113, -113, -113, -113, -113,  652,
 /*   430 */  -113, -113, -113, -113, -113, -113, -113, 1055, 1052, -113,
 /*   440 */  1059, 1057, -113,  751, -113, 1042, -113, -113, -113,  226,
 /*   450 */   883, 1038, 1034, -113, -113, -113, -113, -113, -113,  716,
 /*   460 */  -113, 1044, 1074, -113,  852, 1039, 1078, -113,  865,  885,
 /*   470 */  -113, -113,  867,  885, -113, 1089, 1040,  785, -113, -113,
 /*   480 */   768,  883, -113,  679, -113,  872,  885, -113,  885, -113,
 /*   490 */  1093, 1048, -113, -113, 1094, 1096, -113, 1097, 1102, -113,
 /*   500 */  1101, 1104, -113, 1103, 1105, -113,  883, -113, 1110, 1107,
 /*   510 */  1066, -113, 1071, 1115, 1108, -113,  868, 1076, -113, -113,
 /*   520 */  1118, 1120, 1061,  886,  883, -113,  761, -113, -113, 1125,
 /*   530 */  -113, 1127, 1124, -113,  627, -113, -113, -113, -113, 1062,
 /*   540 */  -113, -113, -113, 1065, -113, -113, 1137, -113, -113, 1067,
 /*   550 */  1129, -113, 1141, 1068, -113, 1138, -113, -113, 1070, 1147,
 /*   560 */  -113, -113, -113, -113,
};
static YYACTIONTYPE yy_default[] = {
 /*     0 */   571,  571,  565,  856,  856,  567,  856,  856,  856,  856,
 /*    10 */   856,  592,  593,  594,  856,  856,  856,  856,  856,  856,
 /*    20 */   856,  856,  856,  856,  856,  856,  856,  585,  595,  605,
 /*    30 */   587,  604,  856,  856,  606,  652,  617,  856,  856,  653,
 /*    40 */   656,  657,  658,  659,  660,  856,  652,  618,  637,  635,
 /*    50 */   856,  638,  639,  856,  709,  652,  619,  707,  708,  652,
 /*    60 */   620,  856,  856,  738,  799,  744,  739,  856,  665,  856,
 /*    70 */   856,  666,  674,  676,  683,  721,  712,  714,  702,  716,
 /*    80 */   671,  856,  601,  856,  602,  856,  603,  717,  856,  718,
 /*    90 */   856,  719,  856,  856,  703,  856,  710,  709,  704,  856,
 /*   100 */   589,  711,  706,  856,  737,  856,  856,  740,  856,  741,
 /*   110 */   742,  743,  745,  746,  749,  856,  750,  856,  751,  856,
 /*   120 */   752,  856,  753,  856,  754,  856,  755,  856,  756,  856,
 /*   130 */   757,  856,  758,  856,  759,  856,  760,  856,  761,  856,
 /*   140 */   856,  762,  763,  764,  856,  765,  856,  766,  856,  767,
 /*   150 */   856,  768,  856,  769,  856,  770,  771,  856,  772,  856,
 /*   160 */   775,  773,  856,  856,  856,  781,  856,  799,  856,  856,
 /*   170 */   856,  856,  856,  784,  798,  856,  776,  856,  777,  856,
 /*   180 */   778,  856,  779,  856,  856,  856,  856,  856,  789,  856,
 /*   190 */   856,  856,  790,  856,  856,  856,  845,  856,  856,  856,
 /*   200 */   846,  856,  856,  856,  847,  856,  856,  856,  848,  856,
 /*   210 */   856,  856,  856,  856,  791,  856,  783,  799,  796,  797,
 /*   220 */   691,  856,  692,  787,  774,  856,  856,  856,  782,  856,
 /*   230 */   799,  856,  786,  856,  785,  691,  788,  710,  709,  705,
 /*   240 */   856,  715,  856,  799,  713,  856,  722,  675,  686,  684,
 /*   250 */   685,  693,  694,  856,  695,  856,  696,  856,  697,  856,
 /*   260 */   691,  682,  590,  591,  856,  680,  681,  699,  701,  687,
 /*   270 */   856,  856,  856,  700,  856,  734,  735,  856,  698,  686,
 /*   280 */   856,  856,  856,  682,  699,  701,  688,  856,  682,  677,
 /*   290 */   678,  856,  856,  679,  672,  673,  780,  856,  736,  856,
 /*   300 */   747,  856,  748,  856,  652,  621,  856,  803,  625,  622,
 /*   310 */   626,  856,  627,  856,  856,  628,  856,  631,  632,  633,
 /*   320 */   634,  856,  629,  856,  630,  856,  856,  804,  856,  710,
 /*   330 */   709,  805,  807,  710,  709,  806,  623,  856,  624,  637,
 /*   340 */   636,  607,  856,  608,  609,  610,  856,  611,  614,  856,
 /*   350 */   612,  615,  613,  616,  596,  856,  856,  597,  856,  856,
 /*   360 */   598,  600,  599,  588,  856,  856,  642,  856,  645,  856,
 /*   370 */   856,  856,  856,  652,  646,  856,  856,  856,  652,  647,
 /*   380 */   856,  652,  648,  856,  856,  856,  856,  856,  856,  803,
 /*   390 */   625,  650,  856,  649,  651,  643,  644,  586,  856,  856,
 /*   400 */   582,  856,  856,  691,  580,  856,  856,  856,  856,  856,
 /*   410 */   856,  691,  828,  856,  856,  856,  691,  833,  856,  856,
 /*   420 */   856,  856,  856,  856,  834,  835,  856,  856,  856,  856,
 /*   430 */   856,  825,  826,  856,  827,  581,  856,  856,  856,  856,
 /*   440 */   856,  856,  856,  856,  856,  856,  856,  856,  856,  856,
 /*   450 */   856,  856,  856,  655,  856,  856,  856,  856,  856,  856,
 /*   460 */   856,  654,  856,  856,  856,  856,  856,  856,  856,  724,
 /*   470 */   856,  856,  856,  725,  856,  856,  732,  856,  856,  733,
 /*   480 */   856,  856,  856,  856,  856,  856,  730,  856,  731,  856,
 /*   490 */   856,  856,  856,  856,  856,  856,  856,  856,  856,  856,
 /*   500 */   856,  856,  856,  856,  856,  856,  856,  856,  856,  691,
 /*   510 */   856,  856,  654,  856,  856,  856,  856,  856,  856,  856,
 /*   520 */   856,  691,  732,  856,  856,  856,  856,  856,  856,  856,
 /*   530 */   856,  856,  691,  856,  822,  856,  856,  856,  856,  856,
 /*   540 */   856,  856,  856,  856,  856,  821,  856,  856,  856,  854,
 /*   550 */   856,  856,  856,  856,  856,  856,  856,  853,  854,  856,
 /*   560 */   856,  568,  570,  566,
};
#define YY_SZ_ACTTAB (sizeof(yy_action)/sizeof(yy_action[0]))

/* The next table maps tokens into fallback tokens.  If a construct
** like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammer, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
    0,  /*          $ => nothing */
    0,  /* END_OF_FILE => nothing */
    0,  /*    ILLEGAL => nothing */
    0,  /*      SPACE => nothing */
    0,  /* UNCLOSED_STRING => nothing */
    0,  /*    COMMENT => nothing */
    0,  /*   FUNCTION => nothing */
    0,  /*     COLUMN => nothing */
    0,  /* AGG_FUNCTION => nothing */
    0,  /*       SEMI => nothing */
   23,  /*    EXPLAIN => ID */
   23,  /*      BEGIN => ID */
    0,  /* TRANSACTION => nothing */
    0,  /*     COMMIT => nothing */
   23,  /*        END => ID */
    0,  /*   ROLLBACK => nothing */
    0,  /*     CREATE => nothing */
    0,  /*      TABLE => nothing */
   23,  /*       TEMP => ID */
    0,  /*         LP => nothing */
    0,  /*         RP => nothing */
    0,  /*         AS => nothing */
    0,  /*      COMMA => nothing */
    0,  /*         ID => nothing */
   23,  /*      ABORT => ID */
   23,  /*      AFTER => ID */
   23,  /*        ASC => ID */
   23,  /*     ATTACH => ID */
   23,  /*     BEFORE => ID */
   23,  /*    CASCADE => ID */
   23,  /*    CLUSTER => ID */
   23,  /*   CONFLICT => ID */
   23,  /*   DATABASE => ID */
   23,  /*   DEFERRED => ID */
   23,  /*       DESC => ID */
   23,  /*     DETACH => ID */
   23,  /*       EACH => ID */
   23,  /*       FAIL => ID */
   23,  /*        FOR => ID */
   23,  /*       GLOB => ID */
   23,  /*     IGNORE => ID */
   23,  /*  IMMEDIATE => ID */
   23,  /*  INITIALLY => ID */
   23,  /*    INSTEAD => ID */
   23,  /*       LIKE => ID */
   23,  /*      MATCH => ID */
   23,  /*        KEY => ID */
   23,  /*         OF => ID */
   23,  /*     OFFSET => ID */
   23,  /*     PRAGMA => ID */
   23,  /*      RAISE => ID */
   23,  /*    REPLACE => ID */
   23,  /*   RESTRICT => ID */
   23,  /*        ROW => ID */
   23,  /*  STATEMENT => ID */
   23,  /*    TRIGGER => ID */
   23,  /*     VACUUM => ID */
   23,  /*       VIEW => ID */
    0,  /*         OR => nothing */
    0,  /*        AND => nothing */
    0,  /*        NOT => nothing */
    0,  /*         EQ => nothing */
    0,  /*         NE => nothing */
    0,  /*     ISNULL => nothing */
    0,  /*    NOTNULL => nothing */
    0,  /*         IS => nothing */
    0,  /*    BETWEEN => nothing */
    0,  /*         IN => nothing */
    0,  /*         GT => nothing */
    0,  /*         GE => nothing */
    0,  /*         LT => nothing */
    0,  /*         LE => nothing */
    0,  /*     BITAND => nothing */
    0,  /*      BITOR => nothing */
    0,  /*     LSHIFT => nothing */
    0,  /*     RSHIFT => nothing */
    0,  /*       PLUS => nothing */
    0,  /*      MINUS => nothing */
    0,  /*       STAR => nothing */
    0,  /*      SLASH => nothing */
    0,  /*        REM => nothing */
    0,  /*     CONCAT => nothing */
    0,  /*     UMINUS => nothing */
    0,  /*      UPLUS => nothing */
    0,  /*     BITNOT => nothing */
    0,  /*     STRING => nothing */
    0,  /*    JOIN_KW => nothing */
    0,  /*    INTEGER => nothing */
    0,  /* CONSTRAINT => nothing */
    0,  /*    DEFAULT => nothing */
    0,  /*      FLOAT => nothing */
    0,  /*       NULL => nothing */
    0,  /*    PRIMARY => nothing */
    0,  /*     UNIQUE => nothing */
    0,  /*      CHECK => nothing */
    0,  /* REFERENCES => nothing */
    0,  /*    COLLATE => nothing */
    0,  /*         ON => nothing */
    0,  /*     DELETE => nothing */
    0,  /*     UPDATE => nothing */
    0,  /*     INSERT => nothing */
    0,  /*        SET => nothing */
    0,  /* DEFERRABLE => nothing */
    0,  /*    FOREIGN => nothing */
    0,  /*       DROP => nothing */
    0,  /*      UNION => nothing */
    0,  /*        ALL => nothing */
    0,  /*  INTERSECT => nothing */
    0,  /*     EXCEPT => nothing */
    0,  /*     SELECT => nothing */
    0,  /*   DISTINCT => nothing */
    0,  /*        DOT => nothing */
    0,  /*       FROM => nothing */
    0,  /*       JOIN => nothing */
    0,  /*      USING => nothing */
    0,  /*      ORDER => nothing */
    0,  /*         BY => nothing */
    0,  /*      GROUP => nothing */
    0,  /*     HAVING => nothing */
    0,  /*      LIMIT => nothing */
    0,  /*      WHERE => nothing */
    0,  /*       INTO => nothing */
    0,  /*     VALUES => nothing */
    0,  /*       BLOB => nothing */
    0,  /*   VARIABLE => nothing */
    0,  /*       CASE => nothing */
    0,  /*       WHEN => nothing */
    0,  /*       THEN => nothing */
    0,  /*       ELSE => nothing */
    0,  /*      INDEX => nothing */
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
*/
struct yyStackEntry {
  int stateno;       /* The state-number */
  int major;         /* The major token value.  This is the code
                     ** number for the token at this stack level */
  YYMINORTYPE minor; /* The user-supplied minor token value.  This
                     ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  int yyidx;                    /* Index of top element in stack */
  int yyerrcnt;                 /* Shifts left before out of the error */
  sqlite3ParserARG_SDECL                /* A place to hold %extra_argument */
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
};
typedef struct yyParser yyParser;

#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void sqlite3ParserTrace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *yyTokenName[] = { 
  "$",             "END_OF_FILE",   "ILLEGAL",       "SPACE",       
  "UNCLOSED_STRING",  "COMMENT",       "FUNCTION",      "COLUMN",      
  "AGG_FUNCTION",  "SEMI",          "EXPLAIN",       "BEGIN",       
  "TRANSACTION",   "COMMIT",        "END",           "ROLLBACK",    
  "CREATE",        "TABLE",         "TEMP",          "LP",          
  "RP",            "AS",            "COMMA",         "ID",          
  "ABORT",         "AFTER",         "ASC",           "ATTACH",      
  "BEFORE",        "CASCADE",       "CLUSTER",       "CONFLICT",    
  "DATABASE",      "DEFERRED",      "DESC",          "DETACH",      
  "EACH",          "FAIL",          "FOR",           "GLOB",        
  "IGNORE",        "IMMEDIATE",     "INITIALLY",     "INSTEAD",     
  "LIKE",          "MATCH",         "KEY",           "OF",          
  "OFFSET",        "PRAGMA",        "RAISE",         "REPLACE",     
  "RESTRICT",      "ROW",           "STATEMENT",     "TRIGGER",     
  "VACUUM",        "VIEW",          "OR",            "AND",         
  "NOT",           "EQ",            "NE",            "ISNULL",      
  "NOTNULL",       "IS",            "BETWEEN",       "IN",          
  "GT",            "GE",            "LT",            "LE",          
  "BITAND",        "BITOR",         "LSHIFT",        "RSHIFT",      
  "PLUS",          "MINUS",         "STAR",          "SLASH",       
  "REM",           "CONCAT",        "UMINUS",        "UPLUS",       
  "BITNOT",        "STRING",        "JOIN_KW",       "INTEGER",     
  "CONSTRAINT",    "DEFAULT",       "FLOAT",         "NULL",        
  "PRIMARY",       "UNIQUE",        "CHECK",         "REFERENCES",  
  "COLLATE",       "ON",            "DELETE",        "UPDATE",      
  "INSERT",        "SET",           "DEFERRABLE",    "FOREIGN",     
  "DROP",          "UNION",         "ALL",           "INTERSECT",   
  "EXCEPT",        "SELECT",        "DISTINCT",      "DOT",         
  "FROM",          "JOIN",          "USING",         "ORDER",       
  "BY",            "GROUP",         "HAVING",        "LIMIT",       
  "WHERE",         "INTO",          "VALUES",        "BLOB",        
  "VARIABLE",      "CASE",          "WHEN",          "THEN",        
  "ELSE",          "INDEX",         "error",         "input",       
  "cmdlist",       "ecmd",          "explain",       "cmdx",        
  "cmd",           "trans_opt",     "nm",            "create_table",
  "create_table_args",  "temp",          "dbnm",          "columnlist",  
  "conslist_opt",  "select",        "column",        "columnid",    
  "type",          "carglist",      "id",            "ids",         
  "typename",      "signed",        "carg",          "ccons",       
  "onconf",        "sortorder",     "expr",          "idxlist_opt", 
  "refargs",       "defer_subclause",  "refarg",        "refact",      
  "init_deferred_pred_opt",  "conslist",      "tcons",         "idxlist",     
  "defer_subclause_opt",  "orconf",        "resolvetype",   "oneselect",   
  "multiselect_op",  "distinct",      "selcollist",    "from",        
  "where_opt",     "groupby_opt",   "having_opt",    "orderby_opt", 
  "limit_opt",     "sclp",          "as",            "seltablist",  
  "stl_prefix",    "joinop",        "on_opt",        "using_opt",   
  "seltablist_paren",  "joinop2",       "inscollist",    "sortlist",    
  "sortitem",      "collate",       "exprlist",      "setlist",     
  "insert_cmd",    "inscollist_opt",  "itemlist",      "likeop",      
  "case_operand",  "case_exprlist",  "case_else",     "expritem",    
  "uniqueflag",    "idxitem",       "plus_num",      "minus_num",   
  "plus_opt",      "number",        "trigger_decl",  "trigger_cmd_list",
  "trigger_time",  "trigger_event",  "foreach_clause",  "when_clause", 
  "trigger_cmd",   "database_kw_opt",  "key_opt",     
};
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *yyRuleName[] = {
 /*   0 */ "input ::= cmdlist",
 /*   1 */ "cmdlist ::= cmdlist ecmd",
 /*   2 */ "cmdlist ::= ecmd",
 /*   3 */ "ecmd ::= explain cmdx SEMI",
 /*   4 */ "ecmd ::= SEMI",
 /*   5 */ "cmdx ::= cmd",
 /*   6 */ "explain ::= EXPLAIN",
 /*   7 */ "explain ::=",
 /*   8 */ "cmd ::= BEGIN trans_opt",
 /*   9 */ "trans_opt ::=",
 /*  10 */ "trans_opt ::= TRANSACTION",
 /*  11 */ "trans_opt ::= TRANSACTION nm",
 /*  12 */ "cmd ::= COMMIT trans_opt",
 /*  13 */ "cmd ::= END trans_opt",
 /*  14 */ "cmd ::= ROLLBACK trans_opt",
 /*  15 */ "cmd ::= create_table create_table_args",
 /*  16 */ "create_table ::= CREATE temp TABLE nm dbnm",
 /*  17 */ "temp ::= TEMP",
 /*  18 */ "temp ::=",
 /*  19 */ "create_table_args ::= LP columnlist conslist_opt RP",
 /*  20 */ "create_table_args ::= AS select",
 /*  21 */ "columnlist ::= columnlist COMMA column",
 /*  22 */ "columnlist ::= column",
 /*  23 */ "column ::= columnid type carglist",
 /*  24 */ "columnid ::= nm",
 /*  25 */ "id ::= ID",
 /*  26 */ "ids ::= ID",
 /*  27 */ "ids ::= STRING",
 /*  28 */ "nm ::= ID",
 /*  29 */ "nm ::= STRING",
 /*  30 */ "nm ::= JOIN_KW",
 /*  31 */ "type ::=",
 /*  32 */ "type ::= typename",
 /*  33 */ "type ::= typename LP signed RP",
 /*  34 */ "type ::= typename LP signed COMMA signed RP",
 /*  35 */ "typename ::= ids",
 /*  36 */ "typename ::= typename ids",
 /*  37 */ "signed ::= INTEGER",
 /*  38 */ "signed ::= PLUS INTEGER",
 /*  39 */ "signed ::= MINUS INTEGER",
 /*  40 */ "carglist ::= carglist carg",
 /*  41 */ "carglist ::=",
 /*  42 */ "carg ::= CONSTRAINT nm ccons",
 /*  43 */ "carg ::= ccons",
 /*  44 */ "carg ::= DEFAULT STRING",
 /*  45 */ "carg ::= DEFAULT ID",
 /*  46 */ "carg ::= DEFAULT INTEGER",
 /*  47 */ "carg ::= DEFAULT PLUS INTEGER",
 /*  48 */ "carg ::= DEFAULT MINUS INTEGER",
 /*  49 */ "carg ::= DEFAULT FLOAT",
 /*  50 */ "carg ::= DEFAULT PLUS FLOAT",
 /*  51 */ "carg ::= DEFAULT MINUS FLOAT",
 /*  52 */ "carg ::= DEFAULT NULL",
 /*  53 */ "ccons ::= NULL onconf",
 /*  54 */ "ccons ::= NOT NULL onconf",
 /*  55 */ "ccons ::= PRIMARY KEY sortorder onconf",
 /*  56 */ "ccons ::= UNIQUE onconf",
 /*  57 */ "ccons ::= CHECK LP expr RP onconf",
 /*  58 */ "ccons ::= REFERENCES nm idxlist_opt refargs",
 /*  59 */ "ccons ::= defer_subclause",
 /*  60 */ "ccons ::= COLLATE id",
 /*  61 */ "refargs ::=",
 /*  62 */ "refargs ::= refargs refarg",
 /*  63 */ "refarg ::= MATCH nm",
 /*  64 */ "refarg ::= ON DELETE refact",
 /*  65 */ "refarg ::= ON UPDATE refact",
 /*  66 */ "refarg ::= ON INSERT refact",
 /*  67 */ "refact ::= SET NULL",
 /*  68 */ "refact ::= SET DEFAULT",
 /*  69 */ "refact ::= CASCADE",
 /*  70 */ "refact ::= RESTRICT",
 /*  71 */ "defer_subclause ::= NOT DEFERRABLE init_deferred_pred_opt",
 /*  72 */ "defer_subclause ::= DEFERRABLE init_deferred_pred_opt",
 /*  73 */ "init_deferred_pred_opt ::=",
 /*  74 */ "init_deferred_pred_opt ::= INITIALLY DEFERRED",
 /*  75 */ "init_deferred_pred_opt ::= INITIALLY IMMEDIATE",
 /*  76 */ "conslist_opt ::=",
 /*  77 */ "conslist_opt ::= COMMA conslist",
 /*  78 */ "conslist ::= conslist COMMA tcons",
 /*  79 */ "conslist ::= conslist tcons",
 /*  80 */ "conslist ::= tcons",
 /*  81 */ "tcons ::= CONSTRAINT nm",
 /*  82 */ "tcons ::= PRIMARY KEY LP idxlist RP onconf",
 /*  83 */ "tcons ::= UNIQUE LP idxlist RP onconf",
 /*  84 */ "tcons ::= CHECK expr onconf",
 /*  85 */ "tcons ::= FOREIGN KEY LP idxlist RP REFERENCES nm idxlist_opt refargs defer_subclause_opt",
 /*  86 */ "defer_subclause_opt ::=",
 /*  87 */ "defer_subclause_opt ::= defer_subclause",
 /*  88 */ "onconf ::=",
 /*  89 */ "onconf ::= ON CONFLICT resolvetype",
 /*  90 */ "orconf ::=",
 /*  91 */ "orconf ::= OR resolvetype",
 /*  92 */ "resolvetype ::= ROLLBACK",
 /*  93 */ "resolvetype ::= ABORT",
 /*  94 */ "resolvetype ::= FAIL",
 /*  95 */ "resolvetype ::= IGNORE",
 /*  96 */ "resolvetype ::= REPLACE",
 /*  97 */ "cmd ::= DROP TABLE nm dbnm",
 /*  98 */ "cmd ::= CREATE temp VIEW nm dbnm AS select",
 /*  99 */ "cmd ::= DROP VIEW nm dbnm",
 /* 100 */ "cmd ::= select",
 /* 101 */ "select ::= oneselect",
 /* 102 */ "select ::= select multiselect_op oneselect",
 /* 103 */ "multiselect_op ::= UNION",
 /* 104 */ "multiselect_op ::= UNION ALL",
 /* 105 */ "multiselect_op ::= INTERSECT",
 /* 106 */ "multiselect_op ::= EXCEPT",
 /* 107 */ "oneselect ::= SELECT distinct selcollist from where_opt groupby_opt having_opt orderby_opt limit_opt",
 /* 108 */ "distinct ::= DISTINCT",
 /* 109 */ "distinct ::= ALL",
 /* 110 */ "distinct ::=",
 /* 111 */ "sclp ::= selcollist COMMA",
 /* 112 */ "sclp ::=",
 /* 113 */ "selcollist ::= sclp expr as",
 /* 114 */ "selcollist ::= sclp STAR",
 /* 115 */ "selcollist ::= sclp nm DOT STAR",
 /* 116 */ "as ::= AS nm",
 /* 117 */ "as ::= ids",
 /* 118 */ "as ::=",
 /* 119 */ "from ::=",
 /* 120 */ "from ::= FROM seltablist",
 /* 121 */ "stl_prefix ::= seltablist joinop",
 /* 122 */ "stl_prefix ::=",
 /* 123 */ "seltablist ::= stl_prefix nm dbnm as on_opt using_opt",
 /* 124 */ "seltablist ::= stl_prefix LP seltablist_paren RP as on_opt using_opt",
 /* 125 */ "seltablist_paren ::= select",
 /* 126 */ "seltablist_paren ::= seltablist",
 /* 127 */ "dbnm ::=",
 /* 128 */ "dbnm ::= DOT nm",
 /* 129 */ "joinop ::= COMMA",
 /* 130 */ "joinop ::= JOIN",
 /* 131 */ "joinop ::= JOIN_KW JOIN",
 /* 132 */ "joinop ::= JOIN_KW nm JOIN",
 /* 133 */ "joinop ::= JOIN_KW nm nm JOIN",
 /* 134 */ "on_opt ::= ON expr",
 /* 135 */ "on_opt ::=",
 /* 136 */ "using_opt ::= USING LP inscollist RP",
 /* 137 */ "using_opt ::=",
 /* 138 */ "orderby_opt ::=",
 /* 139 */ "orderby_opt ::= ORDER BY sortlist",
 /* 140 */ "sortlist ::= sortlist COMMA sortitem collate sortorder",
 /* 141 */ "sortlist ::= sortitem collate sortorder",
 /* 142 */ "sortitem ::= expr",
 /* 143 */ "sortorder ::= ASC",
 /* 144 */ "sortorder ::= DESC",
 /* 145 */ "sortorder ::=",
 /* 146 */ "collate ::=",
 /* 147 */ "collate ::= COLLATE id",
 /* 148 */ "groupby_opt ::=",
 /* 149 */ "groupby_opt ::= GROUP BY exprlist",
 /* 150 */ "having_opt ::=",
 /* 151 */ "having_opt ::= HAVING expr",
 /* 152 */ "limit_opt ::=",
 /* 153 */ "limit_opt ::= LIMIT signed",
 /* 154 */ "limit_opt ::= LIMIT signed OFFSET signed",
 /* 155 */ "limit_opt ::= LIMIT signed COMMA signed",
 /* 156 */ "cmd ::= DELETE FROM nm dbnm where_opt",
 /* 157 */ "where_opt ::=",
 /* 158 */ "where_opt ::= WHERE expr",
 /* 159 */ "cmd ::= UPDATE orconf nm dbnm SET setlist where_opt",
 /* 160 */ "setlist ::= setlist COMMA nm EQ expr",
 /* 161 */ "setlist ::= nm EQ expr",
 /* 162 */ "cmd ::= insert_cmd INTO nm dbnm inscollist_opt VALUES LP itemlist RP",
 /* 163 */ "cmd ::= insert_cmd INTO nm dbnm inscollist_opt select",
 /* 164 */ "insert_cmd ::= INSERT orconf",
 /* 165 */ "insert_cmd ::= REPLACE",
 /* 166 */ "itemlist ::= itemlist COMMA expr",
 /* 167 */ "itemlist ::= expr",
 /* 168 */ "inscollist_opt ::=",
 /* 169 */ "inscollist_opt ::= LP inscollist RP",
 /* 170 */ "inscollist ::= inscollist COMMA nm",
 /* 171 */ "inscollist ::= nm",
 /* 172 */ "expr ::= LP expr RP",
 /* 173 */ "expr ::= NULL",
 /* 174 */ "expr ::= ID",
 /* 175 */ "expr ::= JOIN_KW",
 /* 176 */ "expr ::= nm DOT nm",
 /* 177 */ "expr ::= nm DOT nm DOT nm",
 /* 178 */ "expr ::= INTEGER",
 /* 179 */ "expr ::= FLOAT",
 /* 180 */ "expr ::= STRING",
 /* 181 */ "expr ::= BLOB",
 /* 182 */ "expr ::= VARIABLE",
 /* 183 */ "expr ::= ID LP exprlist RP",
 /* 184 */ "expr ::= ID LP STAR RP",
 /* 185 */ "expr ::= expr AND expr",
 /* 186 */ "expr ::= expr OR expr",
 /* 187 */ "expr ::= expr LT expr",
 /* 188 */ "expr ::= expr GT expr",
 /* 189 */ "expr ::= expr LE expr",
 /* 190 */ "expr ::= expr GE expr",
 /* 191 */ "expr ::= expr NE expr",
 /* 192 */ "expr ::= expr EQ expr",
 /* 193 */ "expr ::= expr BITAND expr",
 /* 194 */ "expr ::= expr BITOR expr",
 /* 195 */ "expr ::= expr LSHIFT expr",
 /* 196 */ "expr ::= expr RSHIFT expr",
 /* 197 */ "expr ::= expr likeop expr",
 /* 198 */ "expr ::= expr NOT likeop expr",
 /* 199 */ "likeop ::= LIKE",
 /* 200 */ "likeop ::= GLOB",
 /* 201 */ "expr ::= expr PLUS expr",
 /* 202 */ "expr ::= expr MINUS expr",
 /* 203 */ "expr ::= expr STAR expr",
 /* 204 */ "expr ::= expr SLASH expr",
 /* 205 */ "expr ::= expr REM expr",
 /* 206 */ "expr ::= expr CONCAT expr",
 /* 207 */ "expr ::= expr ISNULL",
 /* 208 */ "expr ::= expr IS NULL",
 /* 209 */ "expr ::= expr NOTNULL",
 /* 210 */ "expr ::= expr NOT NULL",
 /* 211 */ "expr ::= expr IS NOT NULL",
 /* 212 */ "expr ::= NOT expr",
 /* 213 */ "expr ::= BITNOT expr",
 /* 214 */ "expr ::= MINUS expr",
 /* 215 */ "expr ::= PLUS expr",
 /* 216 */ "expr ::= LP select RP",
 /* 217 */ "expr ::= expr BETWEEN expr AND expr",
 /* 218 */ "expr ::= expr NOT BETWEEN expr AND expr",
 /* 219 */ "expr ::= expr IN LP exprlist RP",
 /* 220 */ "expr ::= expr IN LP select RP",
 /* 221 */ "expr ::= expr NOT IN LP exprlist RP",
 /* 222 */ "expr ::= expr NOT IN LP select RP",
 /* 223 */ "expr ::= expr IN nm dbnm",
 /* 224 */ "expr ::= expr NOT IN nm dbnm",
 /* 225 */ "expr ::= CASE case_operand case_exprlist case_else END",
 /* 226 */ "case_exprlist ::= case_exprlist WHEN expr THEN expr",
 /* 227 */ "case_exprlist ::= WHEN expr THEN expr",
 /* 228 */ "case_else ::= ELSE expr",
 /* 229 */ "case_else ::=",
 /* 230 */ "case_operand ::= expr",
 /* 231 */ "case_operand ::=",
 /* 232 */ "exprlist ::= exprlist COMMA expritem",
 /* 233 */ "exprlist ::= expritem",
 /* 234 */ "expritem ::= expr",
 /* 235 */ "expritem ::=",
 /* 236 */ "cmd ::= CREATE uniqueflag INDEX nm dbnm ON nm dbnm LP idxlist RP onconf",
 /* 237 */ "uniqueflag ::= UNIQUE",
 /* 238 */ "uniqueflag ::=",
 /* 239 */ "idxlist_opt ::=",
 /* 240 */ "idxlist_opt ::= LP idxlist RP",
 /* 241 */ "idxlist ::= idxlist COMMA idxitem collate sortorder",
 /* 242 */ "idxlist ::= idxitem collate sortorder",
 /* 243 */ "idxitem ::= nm",
 /* 244 */ "cmd ::= DROP INDEX nm dbnm",
 /* 245 */ "cmd ::= VACUUM",
 /* 246 */ "cmd ::= VACUUM nm",
 /* 247 */ "cmd ::= PRAGMA nm dbnm EQ nm",
 /* 248 */ "cmd ::= PRAGMA nm dbnm EQ ON",
 /* 249 */ "cmd ::= PRAGMA nm dbnm EQ plus_num",
 /* 250 */ "cmd ::= PRAGMA nm dbnm EQ minus_num",
 /* 251 */ "cmd ::= PRAGMA nm dbnm LP nm RP",
 /* 252 */ "cmd ::= PRAGMA nm dbnm",
 /* 253 */ "plus_num ::= plus_opt number",
 /* 254 */ "minus_num ::= MINUS number",
 /* 255 */ "number ::= INTEGER",
 /* 256 */ "number ::= FLOAT",
 /* 257 */ "plus_opt ::= PLUS",
 /* 258 */ "plus_opt ::=",
 /* 259 */ "cmd ::= CREATE trigger_decl BEGIN trigger_cmd_list END",
 /* 260 */ "trigger_decl ::= temp TRIGGER nm dbnm trigger_time trigger_event ON nm dbnm foreach_clause when_clause",
 /* 261 */ "trigger_time ::= BEFORE",
 /* 262 */ "trigger_time ::= AFTER",
 /* 263 */ "trigger_time ::= INSTEAD OF",
 /* 264 */ "trigger_time ::=",
 /* 265 */ "trigger_event ::= DELETE",
 /* 266 */ "trigger_event ::= INSERT",
 /* 267 */ "trigger_event ::= UPDATE",
 /* 268 */ "trigger_event ::= UPDATE OF inscollist",
 /* 269 */ "foreach_clause ::=",
 /* 270 */ "foreach_clause ::= FOR EACH ROW",
 /* 271 */ "foreach_clause ::= FOR EACH STATEMENT",
 /* 272 */ "when_clause ::=",
 /* 273 */ "when_clause ::= WHEN expr",
 /* 274 */ "trigger_cmd_list ::= trigger_cmd SEMI trigger_cmd_list",
 /* 275 */ "trigger_cmd_list ::=",
 /* 276 */ "trigger_cmd ::= UPDATE orconf nm SET setlist where_opt",
 /* 277 */ "trigger_cmd ::= insert_cmd INTO nm inscollist_opt VALUES LP itemlist RP",
 /* 278 */ "trigger_cmd ::= insert_cmd INTO nm inscollist_opt select",
 /* 279 */ "trigger_cmd ::= DELETE FROM nm where_opt",
 /* 280 */ "trigger_cmd ::= select",
 /* 281 */ "expr ::= RAISE LP IGNORE RP",
 /* 282 */ "expr ::= RAISE LP ROLLBACK COMMA nm RP",
 /* 283 */ "expr ::= RAISE LP ABORT COMMA nm RP",
 /* 284 */ "expr ::= RAISE LP FAIL COMMA nm RP",
 /* 285 */ "cmd ::= DROP TRIGGER nm dbnm",
 /* 286 */ "cmd ::= ATTACH database_kw_opt ids AS nm key_opt",
 /* 287 */ "key_opt ::= USING ids",
 /* 288 */ "key_opt ::=",
 /* 289 */ "database_kw_opt ::= DATABASE",
 /* 290 */ "database_kw_opt ::=",
 /* 291 */ "cmd ::= DETACH database_kw_opt nm",
};
#endif /* NDEBUG */

/*
** This function returns the symbolic name associated with a token
** value.
*/
const char *sqlite3ParserTokenName(int tokenType){
#ifndef NDEBUG
  if( tokenType>0 && tokenType<(sizeof(yyTokenName)/sizeof(yyTokenName[0])) ){
    return yyTokenName[tokenType];
  }else{
    return "Unknown";
  }
#else
  return "";
#endif
}

/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to sqlite3Parser and sqlite3ParserFree.
*/
void *sqlite3ParserAlloc(void *(*mallocProc)(size_t)){
  yyParser *pParser;
  pParser = (yyParser*)(*mallocProc)( (size_t)sizeof(yyParser) );
  if( pParser ){
    pParser->yyidx = -1;
  }
  return pParser;
}

/* The following function deletes the value associated with a
** symbol.  The symbol can be either a terminal or nonterminal.
** "yymajor" is the symbol code, and "yypminor" is a pointer to
** the value.
*/
static void yy_destructor(YYCODETYPE yymajor, YYMINORTYPE *yypminor){
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are not used
    ** inside the C code.
    */
    case 145:
#line 286 "parse.y"
{sqlite3SelectDelete((yypminor->yy375));}
#line 1233 "parse.c"
      break;
    case 158:
#line 533 "parse.y"
{sqlite3ExprDelete((yypminor->yy164));}
#line 1238 "parse.c"
      break;
    case 159:
#line 747 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1243 "parse.c"
      break;
    case 167:
#line 745 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1248 "parse.c"
      break;
    case 171:
#line 288 "parse.y"
{sqlite3SelectDelete((yypminor->yy375));}
#line 1253 "parse.c"
      break;
    case 174:
#line 322 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1258 "parse.c"
      break;
    case 175:
#line 353 "parse.y"
{sqlite3SrcListDelete((yypminor->yy283));}
#line 1263 "parse.c"
      break;
    case 176:
#line 483 "parse.y"
{sqlite3ExprDelete((yypminor->yy164));}
#line 1268 "parse.c"
      break;
    case 177:
#line 459 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1273 "parse.c"
      break;
    case 178:
#line 464 "parse.y"
{sqlite3ExprDelete((yypminor->yy164));}
#line 1278 "parse.c"
      break;
    case 179:
#line 431 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1283 "parse.c"
      break;
    case 181:
#line 324 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1288 "parse.c"
      break;
    case 183:
#line 349 "parse.y"
{sqlite3SrcListDelete((yypminor->yy283));}
#line 1293 "parse.c"
      break;
    case 184:
#line 351 "parse.y"
{sqlite3SrcListDelete((yypminor->yy283));}
#line 1298 "parse.c"
      break;
    case 186:
#line 420 "parse.y"
{sqlite3ExprDelete((yypminor->yy164));}
#line 1303 "parse.c"
      break;
    case 187:
#line 425 "parse.y"
{sqlite3IdListDelete((yypminor->yy246));}
#line 1308 "parse.c"
      break;
    case 188:
#line 400 "parse.y"
{sqlite3SelectDelete((yypminor->yy375));}
#line 1313 "parse.c"
      break;
    case 190:
#line 522 "parse.y"
{sqlite3IdListDelete((yypminor->yy246));}
#line 1318 "parse.c"
      break;
    case 191:
#line 433 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1323 "parse.c"
      break;
    case 192:
#line 435 "parse.y"
{sqlite3ExprDelete((yypminor->yy164));}
#line 1328 "parse.c"
      break;
    case 194:
#line 720 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1333 "parse.c"
      break;
    case 195:
#line 489 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1338 "parse.c"
      break;
    case 197:
#line 520 "parse.y"
{sqlite3IdListDelete((yypminor->yy246));}
#line 1343 "parse.c"
      break;
    case 198:
#line 514 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1348 "parse.c"
      break;
    case 201:
#line 703 "parse.y"
{sqlite3ExprListDelete((yypminor->yy232));}
#line 1353 "parse.c"
      break;
    case 203:
#line 722 "parse.y"
{sqlite3ExprDelete((yypminor->yy164));}
#line 1358 "parse.c"
      break;
    case 211:
#line 839 "parse.y"
{sqlite3DeleteTriggerStep((yypminor->yy353));}
#line 1363 "parse.c"
      break;
    case 213:
#line 823 "parse.y"
{sqlite3IdListDelete((yypminor->yy414).b);}
#line 1368 "parse.c"
      break;
    case 216:
#line 847 "parse.y"
{sqlite3DeleteTriggerStep((yypminor->yy353));}
#line 1373 "parse.c"
      break;
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
**
** Return the major token number for the symbol popped.
*/
static int yy_pop_parser_stack(yyParser *pParser){
  YYCODETYPE yymajor;
  yyStackEntry *yytos = &pParser->yystack[pParser->yyidx];

  if( pParser->yyidx<0 ) return 0;
#ifndef NDEBUG
  if( yyTraceFILE && pParser->yyidx>=0 ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yymajor = yytos->major;
  yy_destructor( yymajor, &yytos->minor);
  pParser->yyidx--;
  return yymajor;
}

/* 
** Deallocate and destroy a parser.  Destructors are all called for
** all stack elements before shutting the parser down.
**
** Inputs:
** <ul>
** <li>  A pointer to the parser.  This should be a pointer
**       obtained from sqlite3ParserAlloc.
** <li>  A pointer to a function used to reclaim memory obtained
**       from malloc.
** </ul>
*/
void sqlite3ParserFree(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
  yyParser *pParser = (yyParser*)p;
  if( pParser==0 ) return;
  while( pParser->yyidx>=0 ) yy_pop_parser_stack(pParser);
  (*freeProc)((void*)pParser);
}

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_shift_action(
  yyParser *pParser,        /* The parser */
  int iLookAhead            /* The look-ahead token */
){
  int i;
  int stateno = pParser->yystack[pParser->yyidx].stateno;
 
  /* if( pParser->yyidx<0 ) return YY_NO_ACTION;  */
  i = yy_shift_ofst[stateno];
  if( i==YY_SHIFT_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
#ifdef YYFALLBACK
    int iFallback;            /* Fallback token */
    if( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0])
           && (iFallback = yyFallback[iLookAhead])!=0 ){
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
           yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
      }
#endif
      return yy_find_shift_action(pParser, iFallback);
    }
#endif
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_reduce_action(
  yyParser *pParser,        /* The parser */
  int iLookAhead            /* The look-ahead token */
){
  int i;
  int stateno = pParser->yystack[pParser->yyidx].stateno;
 
  i = yy_reduce_ofst[stateno];
  if( i==YY_REDUCE_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  int yyNewState,               /* The new state to shift in */
  int yyMajor,                  /* The major token to shift in */
  YYMINORTYPE *yypMinor         /* Pointer ot the minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yyidx++;
  if( yypParser->yyidx>=YYSTACKDEPTH ){
     sqlite3ParserARG_FETCH;
     yypParser->yyidx--;
#ifndef NDEBUG
     if( yyTraceFILE ){
       fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
     }
#endif
     while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
     /* Here code is inserted which will execute if the parser
     ** stack every overflows */
     sqlite3ParserARG_STORE; /* Suppress warning about unused %extra_argument var */
     return;
  }
  yytos = &yypParser->yystack[yypParser->yyidx];
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor = *yypMinor;
#ifndef NDEBUG
  if( yyTraceFILE && yypParser->yyidx>0 ){
    int i;
    fprintf(yyTraceFILE,"%sShift %d\n",yyTracePrompt,yyNewState);
    fprintf(yyTraceFILE,"%sStack:",yyTracePrompt);
    for(i=1; i<=yypParser->yyidx; i++)
      fprintf(yyTraceFILE," %s",yyTokenName[yypParser->yystack[i].major]);
    fprintf(yyTraceFILE,"\n");
  }
#endif
}

/* The following table contains information about every rule that
** is used during the reduce.
*/
static struct {
  YYCODETYPE lhs;         /* Symbol on the left-hand side of the rule */
  unsigned char nrhs;     /* Number of right-hand side symbols in the rule */
} yyRuleInfo[] = {
  { 131, 1 },
  { 132, 2 },
  { 132, 1 },
  { 133, 3 },
  { 133, 1 },
  { 135, 1 },
  { 134, 1 },
  { 134, 0 },
  { 136, 2 },
  { 137, 0 },
  { 137, 1 },
  { 137, 2 },
  { 136, 2 },
  { 136, 2 },
  { 136, 2 },
  { 136, 2 },
  { 139, 5 },
  { 141, 1 },
  { 141, 0 },
  { 140, 4 },
  { 140, 2 },
  { 143, 3 },
  { 143, 1 },
  { 146, 3 },
  { 147, 1 },
  { 150, 1 },
  { 151, 1 },
  { 151, 1 },
  { 138, 1 },
  { 138, 1 },
  { 138, 1 },
  { 148, 0 },
  { 148, 1 },
  { 148, 4 },
  { 148, 6 },
  { 152, 1 },
  { 152, 2 },
  { 153, 1 },
  { 153, 2 },
  { 153, 2 },
  { 149, 2 },
  { 149, 0 },
  { 154, 3 },
  { 154, 1 },
  { 154, 2 },
  { 154, 2 },
  { 154, 2 },
  { 154, 3 },
  { 154, 3 },
  { 154, 2 },
  { 154, 3 },
  { 154, 3 },
  { 154, 2 },
  { 155, 2 },
  { 155, 3 },
  { 155, 4 },
  { 155, 2 },
  { 155, 5 },
  { 155, 4 },
  { 155, 1 },
  { 155, 2 },
  { 160, 0 },
  { 160, 2 },
  { 162, 2 },
  { 162, 3 },
  { 162, 3 },
  { 162, 3 },
  { 163, 2 },
  { 163, 2 },
  { 163, 1 },
  { 163, 1 },
  { 161, 3 },
  { 161, 2 },
  { 164, 0 },
  { 164, 2 },
  { 164, 2 },
  { 144, 0 },
  { 144, 2 },
  { 165, 3 },
  { 165, 2 },
  { 165, 1 },
  { 166, 2 },
  { 166, 6 },
  { 166, 5 },
  { 166, 3 },
  { 166, 10 },
  { 168, 0 },
  { 168, 1 },
  { 156, 0 },
  { 156, 3 },
  { 169, 0 },
  { 169, 2 },
  { 170, 1 },
  { 170, 1 },
  { 170, 1 },
  { 170, 1 },
  { 170, 1 },
  { 136, 4 },
  { 136, 7 },
  { 136, 4 },
  { 136, 1 },
  { 145, 1 },
  { 145, 3 },
  { 172, 1 },
  { 172, 2 },
  { 172, 1 },
  { 172, 1 },
  { 171, 9 },
  { 173, 1 },
  { 173, 1 },
  { 173, 0 },
  { 181, 2 },
  { 181, 0 },
  { 174, 3 },
  { 174, 2 },
  { 174, 4 },
  { 182, 2 },
  { 182, 1 },
  { 182, 0 },
  { 175, 0 },
  { 175, 2 },
  { 184, 2 },
  { 184, 0 },
  { 183, 6 },
  { 183, 7 },
  { 188, 1 },
  { 188, 1 },
  { 142, 0 },
  { 142, 2 },
  { 185, 1 },
  { 185, 1 },
  { 185, 2 },
  { 185, 3 },
  { 185, 4 },
  { 186, 2 },
  { 186, 0 },
  { 187, 4 },
  { 187, 0 },
  { 179, 0 },
  { 179, 3 },
  { 191, 5 },
  { 191, 3 },
  { 192, 1 },
  { 157, 1 },
  { 157, 1 },
  { 157, 0 },
  { 193, 0 },
  { 193, 2 },
  { 177, 0 },
  { 177, 3 },
  { 178, 0 },
  { 178, 2 },
  { 180, 0 },
  { 180, 2 },
  { 180, 4 },
  { 180, 4 },
  { 136, 5 },
  { 176, 0 },
  { 176, 2 },
  { 136, 7 },
  { 195, 5 },
  { 195, 3 },
  { 136, 9 },
  { 136, 6 },
  { 196, 2 },
  { 196, 1 },
  { 198, 3 },
  { 198, 1 },
  { 197, 0 },
  { 197, 3 },
  { 190, 3 },
  { 190, 1 },
  { 158, 3 },
  { 158, 1 },
  { 158, 1 },
  { 158, 1 },
  { 158, 3 },
  { 158, 5 },
  { 158, 1 },
  { 158, 1 },
  { 158, 1 },
  { 158, 1 },
  { 158, 1 },
  { 158, 4 },
  { 158, 4 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 4 },
  { 199, 1 },
  { 199, 1 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 3 },
  { 158, 2 },
  { 158, 3 },
  { 158, 2 },
  { 158, 3 },
  { 158, 4 },
  { 158, 2 },
  { 158, 2 },
  { 158, 2 },
  { 158, 2 },
  { 158, 3 },
  { 158, 5 },
  { 158, 6 },
  { 158, 5 },
  { 158, 5 },
  { 158, 6 },
  { 158, 6 },
  { 158, 4 },
  { 158, 5 },
  { 158, 5 },
  { 201, 5 },
  { 201, 4 },
  { 202, 2 },
  { 202, 0 },
  { 200, 1 },
  { 200, 0 },
  { 194, 3 },
  { 194, 1 },
  { 203, 1 },
  { 203, 0 },
  { 136, 12 },
  { 204, 1 },
  { 204, 0 },
  { 159, 0 },
  { 159, 3 },
  { 167, 5 },
  { 167, 3 },
  { 205, 1 },
  { 136, 4 },
  { 136, 1 },
  { 136, 2 },
  { 136, 5 },
  { 136, 5 },
  { 136, 5 },
  { 136, 5 },
  { 136, 6 },
  { 136, 3 },
  { 206, 2 },
  { 207, 2 },
  { 209, 1 },
  { 209, 1 },
  { 208, 1 },
  { 208, 0 },
  { 136, 5 },
  { 210, 11 },
  { 212, 1 },
  { 212, 1 },
  { 212, 2 },
  { 212, 0 },
  { 213, 1 },
  { 213, 1 },
  { 213, 1 },
  { 213, 3 },
  { 214, 0 },
  { 214, 3 },
  { 214, 3 },
  { 215, 0 },
  { 215, 2 },
  { 211, 3 },
  { 211, 0 },
  { 216, 6 },
  { 216, 8 },
  { 216, 5 },
  { 216, 4 },
  { 216, 1 },
  { 158, 4 },
  { 158, 6 },
  { 158, 6 },
  { 158, 6 },
  { 136, 4 },
  { 136, 6 },
  { 218, 2 },
  { 218, 0 },
  { 217, 1 },
  { 217, 0 },
  { 136, 3 },
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
*/
static void yy_reduce(
  yyParser *yypParser,         /* The parser */
  int yyruleno                 /* Number of the rule by which to reduce */
){
  int yygoto;                     /* The next state */
  int yyact;                      /* The next action */
  YYMINORTYPE yygotominor;        /* The LHS of the rule reduced */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  sqlite3ParserARG_FETCH;
  yymsp = &yypParser->yystack[yypParser->yyidx];
#ifndef NDEBUG
  if( yyTraceFILE && yyruleno>=0 
        && yyruleno<sizeof(yyRuleName)/sizeof(yyRuleName[0]) ){
    fprintf(yyTraceFILE, "%sReduce [%s].\n", yyTracePrompt,
      yyRuleName[yyruleno]);
  }
#endif /* NDEBUG */

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
      case 0:
        /* No destructor defined for cmdlist */
        break;
      case 1:
        /* No destructor defined for cmdlist */
        /* No destructor defined for ecmd */
        break;
      case 2:
        /* No destructor defined for ecmd */
        break;
      case 3:
        /* No destructor defined for explain */
        /* No destructor defined for cmdx */
        /* No destructor defined for SEMI */
        break;
      case 4:
        /* No destructor defined for SEMI */
        break;
      case 5:
#line 72 "parse.y"
{ sqlite3FinishCoding(pParse); }
#line 1898 "parse.c"
        /* No destructor defined for cmd */
        break;
      case 6:
#line 73 "parse.y"
{ sqlite3BeginParse(pParse, 1); }
#line 1904 "parse.c"
        /* No destructor defined for EXPLAIN */
        break;
      case 7:
#line 74 "parse.y"
{ sqlite3BeginParse(pParse, 0); }
#line 1910 "parse.c"
        break;
      case 8:
#line 79 "parse.y"
{sqlite3BeginTransaction(pParse);}
#line 1915 "parse.c"
        /* No destructor defined for BEGIN */
        /* No destructor defined for trans_opt */
        break;
      case 9:
        break;
      case 10:
        /* No destructor defined for TRANSACTION */
        break;
      case 11:
        /* No destructor defined for TRANSACTION */
        /* No destructor defined for nm */
        break;
      case 12:
#line 83 "parse.y"
{sqlite3CommitTransaction(pParse);}
#line 1931 "parse.c"
        /* No destructor defined for COMMIT */
        /* No destructor defined for trans_opt */
        break;
      case 13:
#line 84 "parse.y"
{sqlite3CommitTransaction(pParse);}
#line 1938 "parse.c"
        /* No destructor defined for END */
        /* No destructor defined for trans_opt */
        break;
      case 14:
#line 85 "parse.y"
{sqlite3RollbackTransaction(pParse);}
#line 1945 "parse.c"
        /* No destructor defined for ROLLBACK */
        /* No destructor defined for trans_opt */
        break;
      case 15:
        /* No destructor defined for create_table */
        /* No destructor defined for create_table_args */
        break;
      case 16:
#line 90 "parse.y"
{
   sqlite3StartTable(pParse,&yymsp[-4].minor.yy0,&yymsp[-1].minor.yy318,&yymsp[0].minor.yy318,yymsp[-3].minor.yy424,0);
}
#line 1958 "parse.c"
        /* No destructor defined for TABLE */
        break;
      case 17:
#line 94 "parse.y"
{yygotominor.yy424 = 1;}
#line 1964 "parse.c"
        /* No destructor defined for TEMP */
        break;
      case 18:
#line 95 "parse.y"
{yygotominor.yy424 = 0;}
#line 1970 "parse.c"
        break;
      case 19:
#line 96 "parse.y"
{
  sqlite3EndTable(pParse,&yymsp[0].minor.yy0,0);
}
#line 1977 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for columnlist */
        /* No destructor defined for conslist_opt */
        break;
      case 20:
#line 99 "parse.y"
{
  sqlite3EndTable(pParse,0,yymsp[0].minor.yy375);
  sqlite3SelectDelete(yymsp[0].minor.yy375);
}
#line 1988 "parse.c"
        /* No destructor defined for AS */
        break;
      case 21:
        /* No destructor defined for columnlist */
        /* No destructor defined for COMMA */
        /* No destructor defined for column */
        break;
      case 22:
        /* No destructor defined for column */
        break;
      case 23:
        /* No destructor defined for columnid */
        /* No destructor defined for type */
        /* No destructor defined for carglist */
        break;
      case 24:
#line 111 "parse.y"
{sqlite3AddColumn(pParse,&yymsp[0].minor.yy318);}
#line 2007 "parse.c"
        break;
      case 25:
#line 117 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy0;}
#line 2012 "parse.c"
        break;
      case 26:
#line 149 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy0;}
#line 2017 "parse.c"
        break;
      case 27:
#line 150 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy0;}
#line 2022 "parse.c"
        break;
      case 28:
#line 155 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy0;}
#line 2027 "parse.c"
        break;
      case 29:
#line 156 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy0;}
#line 2032 "parse.c"
        break;
      case 30:
#line 157 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy0;}
#line 2037 "parse.c"
        break;
      case 31:
        break;
      case 32:
#line 160 "parse.y"
{sqlite3AddColumnType(pParse,&yymsp[0].minor.yy318,&yymsp[0].minor.yy318);}
#line 2044 "parse.c"
        break;
      case 33:
#line 161 "parse.y"
{sqlite3AddColumnType(pParse,&yymsp[-3].minor.yy318,&yymsp[0].minor.yy0);}
#line 2049 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for signed */
        break;
      case 34:
#line 163 "parse.y"
{sqlite3AddColumnType(pParse,&yymsp[-5].minor.yy318,&yymsp[0].minor.yy0);}
#line 2056 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for signed */
        /* No destructor defined for COMMA */
        /* No destructor defined for signed */
        break;
      case 35:
#line 165 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy318;}
#line 2065 "parse.c"
        break;
      case 36:
#line 166 "parse.y"
{yygotominor.yy318.z=yymsp[-1].minor.yy318.z; yygotominor.yy318.n=yymsp[-1].minor.yy318.n+Addr(yymsp[0].minor.yy318.z)-Addr(yymsp[-1].minor.yy318.z);}
#line 2070 "parse.c"
        break;
      case 37:
#line 168 "parse.y"
{ yygotominor.yy424 = atoi(yymsp[0].minor.yy0.z); }
#line 2075 "parse.c"
        break;
      case 38:
#line 169 "parse.y"
{ yygotominor.yy424 = atoi(yymsp[0].minor.yy0.z); }
#line 2080 "parse.c"
        /* No destructor defined for PLUS */
        break;
      case 39:
#line 170 "parse.y"
{ yygotominor.yy424 = -atoi(yymsp[0].minor.yy0.z); }
#line 2086 "parse.c"
        /* No destructor defined for MINUS */
        break;
      case 40:
        /* No destructor defined for carglist */
        /* No destructor defined for carg */
        break;
      case 41:
        break;
      case 42:
        /* No destructor defined for CONSTRAINT */
        /* No destructor defined for nm */
        /* No destructor defined for ccons */
        break;
      case 43:
        /* No destructor defined for ccons */
        break;
      case 44:
#line 175 "parse.y"
{sqlite3AddDefaultValue(pParse,&yymsp[0].minor.yy0,0);}
#line 2106 "parse.c"
        /* No destructor defined for DEFAULT */
        break;
      case 45:
#line 176 "parse.y"
{sqlite3AddDefaultValue(pParse,&yymsp[0].minor.yy0,0);}
#line 2112 "parse.c"
        /* No destructor defined for DEFAULT */
        break;
      case 46:
#line 177 "parse.y"
{sqlite3AddDefaultValue(pParse,&yymsp[0].minor.yy0,0);}
#line 2118 "parse.c"
        /* No destructor defined for DEFAULT */
        break;
      case 47:
#line 178 "parse.y"
{sqlite3AddDefaultValue(pParse,&yymsp[0].minor.yy0,0);}
#line 2124 "parse.c"
        /* No destructor defined for DEFAULT */
        /* No destructor defined for PLUS */
        break;
      case 48:
#line 179 "parse.y"
{sqlite3AddDefaultValue(pParse,&yymsp[0].minor.yy0,1);}
#line 2131 "parse.c"
        /* No destructor defined for DEFAULT */
        /* No destructor defined for MINUS */
        break;
      case 49:
#line 180 "parse.y"
{sqlite3AddDefaultValue(pParse,&yymsp[0].minor.yy0,0);}
#line 2138 "parse.c"
        /* No destructor defined for DEFAULT */
        break;
      case 50:
#line 181 "parse.y"
{sqlite3AddDefaultValue(pParse,&yymsp[0].minor.yy0,0);}
#line 2144 "parse.c"
        /* No destructor defined for DEFAULT */
        /* No destructor defined for PLUS */
        break;
      case 51:
#line 182 "parse.y"
{sqlite3AddDefaultValue(pParse,&yymsp[0].minor.yy0,1);}
#line 2151 "parse.c"
        /* No destructor defined for DEFAULT */
        /* No destructor defined for MINUS */
        break;
      case 52:
        /* No destructor defined for DEFAULT */
        /* No destructor defined for NULL */
        break;
      case 53:
        /* No destructor defined for NULL */
        /* No destructor defined for onconf */
        break;
      case 54:
#line 189 "parse.y"
{sqlite3AddNotNull(pParse, yymsp[0].minor.yy424);}
#line 2166 "parse.c"
        /* No destructor defined for NOT */
        /* No destructor defined for NULL */
        break;
      case 55:
#line 190 "parse.y"
{sqlite3AddPrimaryKey(pParse,0,yymsp[0].minor.yy424);}
#line 2173 "parse.c"
        /* No destructor defined for PRIMARY */
        /* No destructor defined for KEY */
        /* No destructor defined for sortorder */
        break;
      case 56:
#line 191 "parse.y"
{sqlite3CreateIndex(pParse,0,0,0,0,yymsp[0].minor.yy424,0,0);}
#line 2181 "parse.c"
        /* No destructor defined for UNIQUE */
        break;
      case 57:
        /* No destructor defined for CHECK */
        /* No destructor defined for LP */
  yy_destructor(158,&yymsp[-2].minor);
        /* No destructor defined for RP */
        /* No destructor defined for onconf */
        break;
      case 58:
#line 194 "parse.y"
{sqlite3CreateForeignKey(pParse,0,&yymsp[-2].minor.yy318,yymsp[-1].minor.yy232,yymsp[0].minor.yy424);}
#line 2194 "parse.c"
        /* No destructor defined for REFERENCES */
        break;
      case 59:
#line 195 "parse.y"
{sqlite3DeferForeignKey(pParse,yymsp[0].minor.yy424);}
#line 2200 "parse.c"
        break;
      case 60:
#line 196 "parse.y"
{sqlite3AddCollateType(pParse, yymsp[0].minor.yy318.z, yymsp[0].minor.yy318.n);}
#line 2205 "parse.c"
        /* No destructor defined for COLLATE */
        break;
      case 61:
#line 204 "parse.y"
{ yygotominor.yy424 = OE_Restrict * 0x010101; }
#line 2211 "parse.c"
        break;
      case 62:
#line 205 "parse.y"
{ yygotominor.yy424 = (yymsp[-1].minor.yy424 & yymsp[0].minor.yy299.mask) | yymsp[0].minor.yy299.value; }
#line 2216 "parse.c"
        break;
      case 63:
#line 207 "parse.y"
{ yygotominor.yy299.value = 0;     yygotominor.yy299.mask = 0x000000; }
#line 2221 "parse.c"
        /* No destructor defined for MATCH */
        /* No destructor defined for nm */
        break;
      case 64:
#line 208 "parse.y"
{ yygotominor.yy299.value = yymsp[0].minor.yy424;     yygotominor.yy299.mask = 0x0000ff; }
#line 2228 "parse.c"
        /* No destructor defined for ON */
        /* No destructor defined for DELETE */
        break;
      case 65:
#line 209 "parse.y"
{ yygotominor.yy299.value = yymsp[0].minor.yy424<<8;  yygotominor.yy299.mask = 0x00ff00; }
#line 2235 "parse.c"
        /* No destructor defined for ON */
        /* No destructor defined for UPDATE */
        break;
      case 66:
#line 210 "parse.y"
{ yygotominor.yy299.value = yymsp[0].minor.yy424<<16; yygotominor.yy299.mask = 0xff0000; }
#line 2242 "parse.c"
        /* No destructor defined for ON */
        /* No destructor defined for INSERT */
        break;
      case 67:
#line 212 "parse.y"
{ yygotominor.yy424 = OE_SetNull; }
#line 2249 "parse.c"
        /* No destructor defined for SET */
        /* No destructor defined for NULL */
        break;
      case 68:
#line 213 "parse.y"
{ yygotominor.yy424 = OE_SetDflt; }
#line 2256 "parse.c"
        /* No destructor defined for SET */
        /* No destructor defined for DEFAULT */
        break;
      case 69:
#line 214 "parse.y"
{ yygotominor.yy424 = OE_Cascade; }
#line 2263 "parse.c"
        /* No destructor defined for CASCADE */
        break;
      case 70:
#line 215 "parse.y"
{ yygotominor.yy424 = OE_Restrict; }
#line 2269 "parse.c"
        /* No destructor defined for RESTRICT */
        break;
      case 71:
#line 217 "parse.y"
{yygotominor.yy424 = yymsp[0].minor.yy424;}
#line 2275 "parse.c"
        /* No destructor defined for NOT */
        /* No destructor defined for DEFERRABLE */
        break;
      case 72:
#line 218 "parse.y"
{yygotominor.yy424 = yymsp[0].minor.yy424;}
#line 2282 "parse.c"
        /* No destructor defined for DEFERRABLE */
        break;
      case 73:
#line 220 "parse.y"
{yygotominor.yy424 = 0;}
#line 2288 "parse.c"
        break;
      case 74:
#line 221 "parse.y"
{yygotominor.yy424 = 1;}
#line 2293 "parse.c"
        /* No destructor defined for INITIALLY */
        /* No destructor defined for DEFERRED */
        break;
      case 75:
#line 222 "parse.y"
{yygotominor.yy424 = 0;}
#line 2300 "parse.c"
        /* No destructor defined for INITIALLY */
        /* No destructor defined for IMMEDIATE */
        break;
      case 76:
        break;
      case 77:
        /* No destructor defined for COMMA */
        /* No destructor defined for conslist */
        break;
      case 78:
        /* No destructor defined for conslist */
        /* No destructor defined for COMMA */
        /* No destructor defined for tcons */
        break;
      case 79:
        /* No destructor defined for conslist */
        /* No destructor defined for tcons */
        break;
      case 80:
        /* No destructor defined for tcons */
        break;
      case 81:
        /* No destructor defined for CONSTRAINT */
        /* No destructor defined for nm */
        break;
      case 82:
#line 234 "parse.y"
{sqlite3AddPrimaryKey(pParse,yymsp[-2].minor.yy232,yymsp[0].minor.yy424);}
#line 2329 "parse.c"
        /* No destructor defined for PRIMARY */
        /* No destructor defined for KEY */
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        break;
      case 83:
#line 236 "parse.y"
{sqlite3CreateIndex(pParse,0,0,0,yymsp[-2].minor.yy232,yymsp[0].minor.yy424,0,0);}
#line 2338 "parse.c"
        /* No destructor defined for UNIQUE */
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        break;
      case 84:
        /* No destructor defined for CHECK */
  yy_destructor(158,&yymsp[-1].minor);
        /* No destructor defined for onconf */
        break;
      case 85:
#line 239 "parse.y"
{
    sqlite3CreateForeignKey(pParse, yymsp[-6].minor.yy232, &yymsp[-3].minor.yy318, yymsp[-2].minor.yy232, yymsp[-1].minor.yy424);
    sqlite3DeferForeignKey(pParse, yymsp[0].minor.yy424);
}
#line 2354 "parse.c"
        /* No destructor defined for FOREIGN */
        /* No destructor defined for KEY */
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        /* No destructor defined for REFERENCES */
        break;
      case 86:
#line 244 "parse.y"
{yygotominor.yy424 = 0;}
#line 2364 "parse.c"
        break;
      case 87:
#line 245 "parse.y"
{yygotominor.yy424 = yymsp[0].minor.yy424;}
#line 2369 "parse.c"
        break;
      case 88:
#line 253 "parse.y"
{ yygotominor.yy424 = OE_Default; }
#line 2374 "parse.c"
        break;
      case 89:
#line 254 "parse.y"
{ yygotominor.yy424 = yymsp[0].minor.yy424; }
#line 2379 "parse.c"
        /* No destructor defined for ON */
        /* No destructor defined for CONFLICT */
        break;
      case 90:
#line 255 "parse.y"
{ yygotominor.yy424 = OE_Default; }
#line 2386 "parse.c"
        break;
      case 91:
#line 256 "parse.y"
{ yygotominor.yy424 = yymsp[0].minor.yy424; }
#line 2391 "parse.c"
        /* No destructor defined for OR */
        break;
      case 92:
#line 257 "parse.y"
{ yygotominor.yy424 = OE_Rollback; }
#line 2397 "parse.c"
        /* No destructor defined for ROLLBACK */
        break;
      case 93:
#line 258 "parse.y"
{ yygotominor.yy424 = OE_Abort; }
#line 2403 "parse.c"
        /* No destructor defined for ABORT */
        break;
      case 94:
#line 259 "parse.y"
{ yygotominor.yy424 = OE_Fail; }
#line 2409 "parse.c"
        /* No destructor defined for FAIL */
        break;
      case 95:
#line 260 "parse.y"
{ yygotominor.yy424 = OE_Ignore; }
#line 2415 "parse.c"
        /* No destructor defined for IGNORE */
        break;
      case 96:
#line 261 "parse.y"
{ yygotominor.yy424 = OE_Replace; }
#line 2421 "parse.c"
        /* No destructor defined for REPLACE */
        break;
      case 97:
#line 265 "parse.y"
{
  sqlite3DropTable(pParse, sqlite3SrcListAppend(0,&yymsp[-1].minor.yy318,&yymsp[0].minor.yy318), 0);
}
#line 2429 "parse.c"
        /* No destructor defined for DROP */
        /* No destructor defined for TABLE */
        break;
      case 98:
#line 271 "parse.y"
{
  sqlite3CreateView(pParse, &yymsp[-6].minor.yy0, &yymsp[-3].minor.yy318, &yymsp[-2].minor.yy318, yymsp[0].minor.yy375, yymsp[-5].minor.yy424);
}
#line 2438 "parse.c"
        /* No destructor defined for VIEW */
        /* No destructor defined for AS */
        break;
      case 99:
#line 274 "parse.y"
{
  sqlite3DropTable(pParse, sqlite3SrcListAppend(0,&yymsp[-1].minor.yy318,&yymsp[0].minor.yy318), 1);
}
#line 2447 "parse.c"
        /* No destructor defined for DROP */
        /* No destructor defined for VIEW */
        break;
      case 100:
#line 280 "parse.y"
{
  sqlite3Select(pParse, yymsp[0].minor.yy375, SRT_Callback, 0, 0, 0, 0, 0);
  sqlite3SelectDelete(yymsp[0].minor.yy375);
}
#line 2457 "parse.c"
        break;
      case 101:
#line 290 "parse.y"
{yygotominor.yy375 = yymsp[0].minor.yy375;}
#line 2462 "parse.c"
        break;
      case 102:
#line 291 "parse.y"
{
  if( yymsp[0].minor.yy375 ){
    yymsp[0].minor.yy375->op = yymsp[-1].minor.yy424;
    yymsp[0].minor.yy375->pPrior = yymsp[-2].minor.yy375;
  }
  yygotominor.yy375 = yymsp[0].minor.yy375;
}
#line 2473 "parse.c"
        break;
      case 103:
#line 299 "parse.y"
{yygotominor.yy424 = TK_UNION;}
#line 2478 "parse.c"
        /* No destructor defined for UNION */
        break;
      case 104:
#line 300 "parse.y"
{yygotominor.yy424 = TK_ALL;}
#line 2484 "parse.c"
        /* No destructor defined for UNION */
        /* No destructor defined for ALL */
        break;
      case 105:
#line 301 "parse.y"
{yygotominor.yy424 = TK_INTERSECT;}
#line 2491 "parse.c"
        /* No destructor defined for INTERSECT */
        break;
      case 106:
#line 302 "parse.y"
{yygotominor.yy424 = TK_EXCEPT;}
#line 2497 "parse.c"
        /* No destructor defined for EXCEPT */
        break;
      case 107:
#line 304 "parse.y"
{
  yygotominor.yy375 = sqlite3SelectNew(yymsp[-6].minor.yy232,yymsp[-5].minor.yy283,yymsp[-4].minor.yy164,yymsp[-3].minor.yy232,yymsp[-2].minor.yy164,yymsp[-1].minor.yy232,yymsp[-7].minor.yy424,yymsp[0].minor.yy22.limit,yymsp[0].minor.yy22.offset);
}
#line 2505 "parse.c"
        /* No destructor defined for SELECT */
        break;
      case 108:
#line 312 "parse.y"
{yygotominor.yy424 = 1;}
#line 2511 "parse.c"
        /* No destructor defined for DISTINCT */
        break;
      case 109:
#line 313 "parse.y"
{yygotominor.yy424 = 0;}
#line 2517 "parse.c"
        /* No destructor defined for ALL */
        break;
      case 110:
#line 314 "parse.y"
{yygotominor.yy424 = 0;}
#line 2523 "parse.c"
        break;
      case 111:
#line 325 "parse.y"
{yygotominor.yy232 = yymsp[-1].minor.yy232;}
#line 2528 "parse.c"
        /* No destructor defined for COMMA */
        break;
      case 112:
#line 326 "parse.y"
{yygotominor.yy232 = 0;}
#line 2534 "parse.c"
        break;
      case 113:
#line 327 "parse.y"
{
   yygotominor.yy232 = sqlite3ExprListAppend(yymsp[-2].minor.yy232,yymsp[-1].minor.yy164,yymsp[0].minor.yy318.n?&yymsp[0].minor.yy318:0);
}
#line 2541 "parse.c"
        break;
      case 114:
#line 330 "parse.y"
{
  yygotominor.yy232 = sqlite3ExprListAppend(yymsp[-1].minor.yy232, sqlite3Expr(TK_ALL, 0, 0, 0), 0);
}
#line 2548 "parse.c"
        /* No destructor defined for STAR */
        break;
      case 115:
#line 333 "parse.y"
{
  Expr *pRight = sqlite3Expr(TK_ALL, 0, 0, 0);
  Expr *pLeft = sqlite3Expr(TK_ID, 0, 0, &yymsp[-2].minor.yy318);
  yygotominor.yy232 = sqlite3ExprListAppend(yymsp[-3].minor.yy232, sqlite3Expr(TK_DOT, pLeft, pRight, 0), 0);
}
#line 2558 "parse.c"
        /* No destructor defined for DOT */
        /* No destructor defined for STAR */
        break;
      case 116:
#line 343 "parse.y"
{ yygotominor.yy318 = yymsp[0].minor.yy318; }
#line 2565 "parse.c"
        /* No destructor defined for AS */
        break;
      case 117:
#line 344 "parse.y"
{ yygotominor.yy318 = yymsp[0].minor.yy318; }
#line 2571 "parse.c"
        break;
      case 118:
#line 345 "parse.y"
{ yygotominor.yy318.n = 0; }
#line 2576 "parse.c"
        break;
      case 119:
#line 357 "parse.y"
{yygotominor.yy283 = sqliteMalloc(sizeof(*yygotominor.yy283));}
#line 2581 "parse.c"
        break;
      case 120:
#line 358 "parse.y"
{yygotominor.yy283 = yymsp[0].minor.yy283;}
#line 2586 "parse.c"
        /* No destructor defined for FROM */
        break;
      case 121:
#line 363 "parse.y"
{
   yygotominor.yy283 = yymsp[-1].minor.yy283;
   if( yygotominor.yy283 && yygotominor.yy283->nSrc>0 ) yygotominor.yy283->a[yygotominor.yy283->nSrc-1].jointype = yymsp[0].minor.yy424;
}
#line 2595 "parse.c"
        break;
      case 122:
#line 367 "parse.y"
{yygotominor.yy283 = 0;}
#line 2600 "parse.c"
        break;
      case 123:
#line 368 "parse.y"
{
  yygotominor.yy283 = sqlite3SrcListAppend(yymsp[-5].minor.yy283,&yymsp[-4].minor.yy318,&yymsp[-3].minor.yy318);
  if( yymsp[-2].minor.yy318.n ) sqlite3SrcListAddAlias(yygotominor.yy283,&yymsp[-2].minor.yy318);
  if( yymsp[-1].minor.yy164 ){
    if( yygotominor.yy283 && yygotominor.yy283->nSrc>1 ){ yygotominor.yy283->a[yygotominor.yy283->nSrc-2].pOn = yymsp[-1].minor.yy164; }
    else { sqlite3ExprDelete(yymsp[-1].minor.yy164); }
  }
  if( yymsp[0].minor.yy246 ){
    if( yygotominor.yy283 && yygotominor.yy283->nSrc>1 ){ yygotominor.yy283->a[yygotominor.yy283->nSrc-2].pUsing = yymsp[0].minor.yy246; }
    else { sqlite3IdListDelete(yymsp[0].minor.yy246); }
  }
}
#line 2616 "parse.c"
        break;
      case 124:
#line 381 "parse.y"
{
  yygotominor.yy283 = sqlite3SrcListAppend(yymsp[-6].minor.yy283,0,0);
  yygotominor.yy283->a[yygotominor.yy283->nSrc-1].pSelect = yymsp[-4].minor.yy375;
  if( yymsp[-2].minor.yy318.n ) sqlite3SrcListAddAlias(yygotominor.yy283,&yymsp[-2].minor.yy318);
  if( yymsp[-1].minor.yy164 ){
    if( yygotominor.yy283 && yygotominor.yy283->nSrc>1 ){ yygotominor.yy283->a[yygotominor.yy283->nSrc-2].pOn = yymsp[-1].minor.yy164; }
    else { sqlite3ExprDelete(yymsp[-1].minor.yy164); }
  }
  if( yymsp[0].minor.yy246 ){
    if( yygotominor.yy283 && yygotominor.yy283->nSrc>1 ){ yygotominor.yy283->a[yygotominor.yy283->nSrc-2].pUsing = yymsp[0].minor.yy246; }
    else { sqlite3IdListDelete(yymsp[0].minor.yy246); }
  }
}
#line 2633 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        break;
      case 125:
#line 401 "parse.y"
{yygotominor.yy375 = yymsp[0].minor.yy375;}
#line 2640 "parse.c"
        break;
      case 126:
#line 402 "parse.y"
{
   yygotominor.yy375 = sqlite3SelectNew(0,yymsp[0].minor.yy283,0,0,0,0,0,-1,0);
}
#line 2647 "parse.c"
        break;
      case 127:
#line 407 "parse.y"
{yygotominor.yy318.z=0; yygotominor.yy318.n=0;}
#line 2652 "parse.c"
        break;
      case 128:
#line 408 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy318;}
#line 2657 "parse.c"
        /* No destructor defined for DOT */
        break;
      case 129:
#line 412 "parse.y"
{ yygotominor.yy424 = JT_INNER; }
#line 2663 "parse.c"
        /* No destructor defined for COMMA */
        break;
      case 130:
#line 413 "parse.y"
{ yygotominor.yy424 = JT_INNER; }
#line 2669 "parse.c"
        /* No destructor defined for JOIN */
        break;
      case 131:
#line 414 "parse.y"
{ yygotominor.yy424 = sqlite3JoinType(pParse,&yymsp[-1].minor.yy0,0,0); }
#line 2675 "parse.c"
        /* No destructor defined for JOIN */
        break;
      case 132:
#line 415 "parse.y"
{ yygotominor.yy424 = sqlite3JoinType(pParse,&yymsp[-2].minor.yy0,&yymsp[-1].minor.yy318,0); }
#line 2681 "parse.c"
        /* No destructor defined for JOIN */
        break;
      case 133:
#line 417 "parse.y"
{ yygotominor.yy424 = sqlite3JoinType(pParse,&yymsp[-3].minor.yy0,&yymsp[-2].minor.yy318,&yymsp[-1].minor.yy318); }
#line 2687 "parse.c"
        /* No destructor defined for JOIN */
        break;
      case 134:
#line 421 "parse.y"
{yygotominor.yy164 = yymsp[0].minor.yy164;}
#line 2693 "parse.c"
        /* No destructor defined for ON */
        break;
      case 135:
#line 422 "parse.y"
{yygotominor.yy164 = 0;}
#line 2699 "parse.c"
        break;
      case 136:
#line 426 "parse.y"
{yygotominor.yy246 = yymsp[-1].minor.yy246;}
#line 2704 "parse.c"
        /* No destructor defined for USING */
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        break;
      case 137:
#line 427 "parse.y"
{yygotominor.yy246 = 0;}
#line 2712 "parse.c"
        break;
      case 138:
#line 437 "parse.y"
{yygotominor.yy232 = 0;}
#line 2717 "parse.c"
        break;
      case 139:
#line 438 "parse.y"
{yygotominor.yy232 = yymsp[0].minor.yy232;}
#line 2722 "parse.c"
        /* No destructor defined for ORDER */
        /* No destructor defined for BY */
        break;
      case 140:
#line 439 "parse.y"
{
  yygotominor.yy232 = sqlite3ExprListAppend(yymsp[-4].minor.yy232,yymsp[-2].minor.yy164,yymsp[-1].minor.yy318.n>0?&yymsp[-1].minor.yy318:0);
  if( yygotominor.yy232 ) yygotominor.yy232->a[yygotominor.yy232->nExpr-1].sortOrder = yymsp[0].minor.yy424;
}
#line 2732 "parse.c"
        /* No destructor defined for COMMA */
        break;
      case 141:
#line 443 "parse.y"
{
  yygotominor.yy232 = sqlite3ExprListAppend(0,yymsp[-2].minor.yy164,yymsp[-1].minor.yy318.n>0?&yymsp[-1].minor.yy318:0);
  if( yygotominor.yy232 && yygotominor.yy232->a ) yygotominor.yy232->a[0].sortOrder = yymsp[0].minor.yy424;
}
#line 2741 "parse.c"
        break;
      case 142:
#line 447 "parse.y"
{yygotominor.yy164 = yymsp[0].minor.yy164;}
#line 2746 "parse.c"
        break;
      case 143:
#line 452 "parse.y"
{yygotominor.yy424 = SQLITE_SO_ASC;}
#line 2751 "parse.c"
        /* No destructor defined for ASC */
        break;
      case 144:
#line 453 "parse.y"
{yygotominor.yy424 = SQLITE_SO_DESC;}
#line 2757 "parse.c"
        /* No destructor defined for DESC */
        break;
      case 145:
#line 454 "parse.y"
{yygotominor.yy424 = SQLITE_SO_ASC;}
#line 2763 "parse.c"
        break;
      case 146:
#line 455 "parse.y"
{yygotominor.yy318.z = 0; yygotominor.yy318.n = 0;}
#line 2768 "parse.c"
        break;
      case 147:
#line 456 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy318;}
#line 2773 "parse.c"
        /* No destructor defined for COLLATE */
        break;
      case 148:
#line 460 "parse.y"
{yygotominor.yy232 = 0;}
#line 2779 "parse.c"
        break;
      case 149:
#line 461 "parse.y"
{yygotominor.yy232 = yymsp[0].minor.yy232;}
#line 2784 "parse.c"
        /* No destructor defined for GROUP */
        /* No destructor defined for BY */
        break;
      case 150:
#line 465 "parse.y"
{yygotominor.yy164 = 0;}
#line 2791 "parse.c"
        break;
      case 151:
#line 466 "parse.y"
{yygotominor.yy164 = yymsp[0].minor.yy164;}
#line 2796 "parse.c"
        /* No destructor defined for HAVING */
        break;
      case 152:
#line 469 "parse.y"
{yygotominor.yy22.limit = -1; yygotominor.yy22.offset = 0;}
#line 2802 "parse.c"
        break;
      case 153:
#line 470 "parse.y"
{yygotominor.yy22.limit = yymsp[0].minor.yy424; yygotominor.yy22.offset = 0;}
#line 2807 "parse.c"
        /* No destructor defined for LIMIT */
        break;
      case 154:
#line 472 "parse.y"
{yygotominor.yy22.limit = yymsp[-2].minor.yy424; yygotominor.yy22.offset = yymsp[0].minor.yy424;}
#line 2813 "parse.c"
        /* No destructor defined for LIMIT */
        /* No destructor defined for OFFSET */
        break;
      case 155:
#line 474 "parse.y"
{yygotominor.yy22.limit = yymsp[0].minor.yy424; yygotominor.yy22.offset = yymsp[-2].minor.yy424;}
#line 2820 "parse.c"
        /* No destructor defined for LIMIT */
        /* No destructor defined for COMMA */
        break;
      case 156:
#line 478 "parse.y"
{
   sqlite3DeleteFrom(pParse, sqlite3SrcListAppend(0,&yymsp[-2].minor.yy318,&yymsp[-1].minor.yy318), yymsp[0].minor.yy164);
}
#line 2829 "parse.c"
        /* No destructor defined for DELETE */
        /* No destructor defined for FROM */
        break;
      case 157:
#line 485 "parse.y"
{yygotominor.yy164 = 0;}
#line 2836 "parse.c"
        break;
      case 158:
#line 486 "parse.y"
{yygotominor.yy164 = yymsp[0].minor.yy164;}
#line 2841 "parse.c"
        /* No destructor defined for WHERE */
        break;
      case 159:
#line 494 "parse.y"
{sqlite3Update(pParse,sqlite3SrcListAppend(0,&yymsp[-4].minor.yy318,&yymsp[-3].minor.yy318),yymsp[-1].minor.yy232,yymsp[0].minor.yy164,yymsp[-5].minor.yy424);}
#line 2847 "parse.c"
        /* No destructor defined for UPDATE */
        /* No destructor defined for SET */
        break;
      case 160:
#line 497 "parse.y"
{yygotominor.yy232 = sqlite3ExprListAppend(yymsp[-4].minor.yy232,yymsp[0].minor.yy164,&yymsp[-2].minor.yy318);}
#line 2854 "parse.c"
        /* No destructor defined for COMMA */
        /* No destructor defined for EQ */
        break;
      case 161:
#line 498 "parse.y"
{yygotominor.yy232 = sqlite3ExprListAppend(0,yymsp[0].minor.yy164,&yymsp[-2].minor.yy318);}
#line 2861 "parse.c"
        /* No destructor defined for EQ */
        break;
      case 162:
#line 504 "parse.y"
{sqlite3Insert(pParse, sqlite3SrcListAppend(0,&yymsp[-6].minor.yy318,&yymsp[-5].minor.yy318), yymsp[-1].minor.yy232, 0, yymsp[-4].minor.yy246, yymsp[-8].minor.yy424);}
#line 2867 "parse.c"
        /* No destructor defined for INTO */
        /* No destructor defined for VALUES */
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        break;
      case 163:
#line 506 "parse.y"
{sqlite3Insert(pParse, sqlite3SrcListAppend(0,&yymsp[-3].minor.yy318,&yymsp[-2].minor.yy318), 0, yymsp[0].minor.yy375, yymsp[-1].minor.yy246, yymsp[-5].minor.yy424);}
#line 2876 "parse.c"
        /* No destructor defined for INTO */
        break;
      case 164:
#line 509 "parse.y"
{yygotominor.yy424 = yymsp[0].minor.yy424;}
#line 2882 "parse.c"
        /* No destructor defined for INSERT */
        break;
      case 165:
#line 510 "parse.y"
{yygotominor.yy424 = OE_Replace;}
#line 2888 "parse.c"
        /* No destructor defined for REPLACE */
        break;
      case 166:
#line 516 "parse.y"
{yygotominor.yy232 = sqlite3ExprListAppend(yymsp[-2].minor.yy232,yymsp[0].minor.yy164,0);}
#line 2894 "parse.c"
        /* No destructor defined for COMMA */
        break;
      case 167:
#line 517 "parse.y"
{yygotominor.yy232 = sqlite3ExprListAppend(0,yymsp[0].minor.yy164,0);}
#line 2900 "parse.c"
        break;
      case 168:
#line 524 "parse.y"
{yygotominor.yy246 = 0;}
#line 2905 "parse.c"
        break;
      case 169:
#line 525 "parse.y"
{yygotominor.yy246 = yymsp[-1].minor.yy246;}
#line 2910 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        break;
      case 170:
#line 526 "parse.y"
{yygotominor.yy246 = sqlite3IdListAppend(yymsp[-2].minor.yy246,&yymsp[0].minor.yy318);}
#line 2917 "parse.c"
        /* No destructor defined for COMMA */
        break;
      case 171:
#line 527 "parse.y"
{yygotominor.yy246 = sqlite3IdListAppend(0,&yymsp[0].minor.yy318);}
#line 2923 "parse.c"
        break;
      case 172:
#line 535 "parse.y"
{yygotominor.yy164 = yymsp[-1].minor.yy164; sqlite3ExprSpan(yygotominor.yy164,&yymsp[-2].minor.yy0,&yymsp[0].minor.yy0); }
#line 2928 "parse.c"
        break;
      case 173:
#line 536 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_NULL, 0, 0, &yymsp[0].minor.yy0);}
#line 2933 "parse.c"
        break;
      case 174:
#line 537 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_ID, 0, 0, &yymsp[0].minor.yy0);}
#line 2938 "parse.c"
        break;
      case 175:
#line 538 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_ID, 0, 0, &yymsp[0].minor.yy0);}
#line 2943 "parse.c"
        break;
      case 176:
#line 539 "parse.y"
{
  Expr *temp1 = sqlite3Expr(TK_ID, 0, 0, &yymsp[-2].minor.yy318);
  Expr *temp2 = sqlite3Expr(TK_ID, 0, 0, &yymsp[0].minor.yy318);
  yygotominor.yy164 = sqlite3Expr(TK_DOT, temp1, temp2, 0);
}
#line 2952 "parse.c"
        /* No destructor defined for DOT */
        break;
      case 177:
#line 544 "parse.y"
{
  Expr *temp1 = sqlite3Expr(TK_ID, 0, 0, &yymsp[-4].minor.yy318);
  Expr *temp2 = sqlite3Expr(TK_ID, 0, 0, &yymsp[-2].minor.yy318);
  Expr *temp3 = sqlite3Expr(TK_ID, 0, 0, &yymsp[0].minor.yy318);
  Expr *temp4 = sqlite3Expr(TK_DOT, temp2, temp3, 0);
  yygotominor.yy164 = sqlite3Expr(TK_DOT, temp1, temp4, 0);
}
#line 2964 "parse.c"
        /* No destructor defined for DOT */
        /* No destructor defined for DOT */
        break;
      case 178:
#line 551 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_INTEGER, 0, 0, &yymsp[0].minor.yy0);}
#line 2971 "parse.c"
        break;
      case 179:
#line 552 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_FLOAT, 0, 0, &yymsp[0].minor.yy0);}
#line 2976 "parse.c"
        break;
      case 180:
#line 553 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_STRING, 0, 0, &yymsp[0].minor.yy0);}
#line 2981 "parse.c"
        break;
      case 181:
#line 554 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_BLOB, 0, 0, &yymsp[0].minor.yy0);}
#line 2986 "parse.c"
        break;
      case 182:
#line 555 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_VARIABLE, 0, 0, &yymsp[0].minor.yy0);
  if( yygotominor.yy164 ) yygotominor.yy164->iTable = ++pParse->nVar;
}
#line 2994 "parse.c"
        break;
      case 183:
#line 559 "parse.y"
{
  yygotominor.yy164 = sqlite3ExprFunction(yymsp[-1].minor.yy232, &yymsp[-3].minor.yy0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-3].minor.yy0,&yymsp[0].minor.yy0);
}
#line 3002 "parse.c"
        /* No destructor defined for LP */
        break;
      case 184:
#line 563 "parse.y"
{
  yygotominor.yy164 = sqlite3ExprFunction(0, &yymsp[-3].minor.yy0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-3].minor.yy0,&yymsp[0].minor.yy0);
}
#line 3011 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for STAR */
        break;
      case 185:
#line 567 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_AND, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3018 "parse.c"
        /* No destructor defined for AND */
        break;
      case 186:
#line 568 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_OR, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3024 "parse.c"
        /* No destructor defined for OR */
        break;
      case 187:
#line 569 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_LT, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3030 "parse.c"
        /* No destructor defined for LT */
        break;
      case 188:
#line 570 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_GT, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3036 "parse.c"
        /* No destructor defined for GT */
        break;
      case 189:
#line 571 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_LE, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3042 "parse.c"
        /* No destructor defined for LE */
        break;
      case 190:
#line 572 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_GE, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3048 "parse.c"
        /* No destructor defined for GE */
        break;
      case 191:
#line 573 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_NE, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3054 "parse.c"
        /* No destructor defined for NE */
        break;
      case 192:
#line 574 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_EQ, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3060 "parse.c"
        /* No destructor defined for EQ */
        break;
      case 193:
#line 575 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_BITAND, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3066 "parse.c"
        /* No destructor defined for BITAND */
        break;
      case 194:
#line 576 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_BITOR, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3072 "parse.c"
        /* No destructor defined for BITOR */
        break;
      case 195:
#line 577 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_LSHIFT, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3078 "parse.c"
        /* No destructor defined for LSHIFT */
        break;
      case 196:
#line 578 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_RSHIFT, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3084 "parse.c"
        /* No destructor defined for RSHIFT */
        break;
      case 197:
#line 579 "parse.y"
{
  ExprList *pList = sqlite3ExprListAppend(0, yymsp[0].minor.yy164, 0);
  pList = sqlite3ExprListAppend(pList, yymsp[-2].minor.yy164, 0);
  yygotominor.yy164 = sqlite3ExprFunction(pList, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->op = yymsp[-1].minor.yy424;
  sqlite3ExprSpan(yygotominor.yy164, &yymsp[-2].minor.yy164->span, &yymsp[0].minor.yy164->span);
}
#line 3096 "parse.c"
        break;
      case 198:
#line 586 "parse.y"
{
  ExprList *pList = sqlite3ExprListAppend(0, yymsp[0].minor.yy164, 0);
  pList = sqlite3ExprListAppend(pList, yymsp[-3].minor.yy164, 0);
  yygotominor.yy164 = sqlite3ExprFunction(pList, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->op = yymsp[-1].minor.yy424;
  yygotominor.yy164 = sqlite3Expr(TK_NOT, yygotominor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-3].minor.yy164->span,&yymsp[0].minor.yy164->span);
}
#line 3108 "parse.c"
        /* No destructor defined for NOT */
        break;
      case 199:
#line 595 "parse.y"
{yygotominor.yy424 = TK_LIKE;}
#line 3114 "parse.c"
        /* No destructor defined for LIKE */
        break;
      case 200:
#line 596 "parse.y"
{yygotominor.yy424 = TK_GLOB;}
#line 3120 "parse.c"
        /* No destructor defined for GLOB */
        break;
      case 201:
#line 597 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_PLUS, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3126 "parse.c"
        /* No destructor defined for PLUS */
        break;
      case 202:
#line 598 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_MINUS, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3132 "parse.c"
        /* No destructor defined for MINUS */
        break;
      case 203:
#line 599 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_STAR, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3138 "parse.c"
        /* No destructor defined for STAR */
        break;
      case 204:
#line 600 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_SLASH, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3144 "parse.c"
        /* No destructor defined for SLASH */
        break;
      case 205:
#line 601 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_REM, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3150 "parse.c"
        /* No destructor defined for REM */
        break;
      case 206:
#line 602 "parse.y"
{yygotominor.yy164 = sqlite3Expr(TK_CONCAT, yymsp[-2].minor.yy164, yymsp[0].minor.yy164, 0);}
#line 3156 "parse.c"
        /* No destructor defined for CONCAT */
        break;
      case 207:
#line 603 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_ISNULL, yymsp[-1].minor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-1].minor.yy164->span,&yymsp[0].minor.yy0);
}
#line 3165 "parse.c"
        break;
      case 208:
#line 607 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_ISNULL, yymsp[-2].minor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-2].minor.yy164->span,&yymsp[0].minor.yy0);
}
#line 3173 "parse.c"
        /* No destructor defined for IS */
        break;
      case 209:
#line 611 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_NOTNULL, yymsp[-1].minor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-1].minor.yy164->span,&yymsp[0].minor.yy0);
}
#line 3182 "parse.c"
        break;
      case 210:
#line 615 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_NOTNULL, yymsp[-2].minor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-2].minor.yy164->span,&yymsp[0].minor.yy0);
}
#line 3190 "parse.c"
        /* No destructor defined for NOT */
        break;
      case 211:
#line 619 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_NOTNULL, yymsp[-3].minor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-3].minor.yy164->span,&yymsp[0].minor.yy0);
}
#line 3199 "parse.c"
        /* No destructor defined for IS */
        /* No destructor defined for NOT */
        break;
      case 212:
#line 623 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_NOT, yymsp[0].minor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-1].minor.yy0,&yymsp[0].minor.yy164->span);
}
#line 3209 "parse.c"
        break;
      case 213:
#line 627 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_BITNOT, yymsp[0].minor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-1].minor.yy0,&yymsp[0].minor.yy164->span);
}
#line 3217 "parse.c"
        break;
      case 214:
#line 631 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_UMINUS, yymsp[0].minor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-1].minor.yy0,&yymsp[0].minor.yy164->span);
}
#line 3225 "parse.c"
        break;
      case 215:
#line 635 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_UPLUS, yymsp[0].minor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-1].minor.yy0,&yymsp[0].minor.yy164->span);
}
#line 3233 "parse.c"
        break;
      case 216:
#line 639 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_SELECT, 0, 0, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pSelect = yymsp[-1].minor.yy375;
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-2].minor.yy0,&yymsp[0].minor.yy0);
}
#line 3242 "parse.c"
        break;
      case 217:
#line 644 "parse.y"
{
  ExprList *pList = sqlite3ExprListAppend(0, yymsp[-2].minor.yy164, 0);
  pList = sqlite3ExprListAppend(pList, yymsp[0].minor.yy164, 0);
  yygotominor.yy164 = sqlite3Expr(TK_BETWEEN, yymsp[-4].minor.yy164, 0, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pList = pList;
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-4].minor.yy164->span,&yymsp[0].minor.yy164->span);
}
#line 3253 "parse.c"
        /* No destructor defined for BETWEEN */
        /* No destructor defined for AND */
        break;
      case 218:
#line 651 "parse.y"
{
  ExprList *pList = sqlite3ExprListAppend(0, yymsp[-2].minor.yy164, 0);
  pList = sqlite3ExprListAppend(pList, yymsp[0].minor.yy164, 0);
  yygotominor.yy164 = sqlite3Expr(TK_BETWEEN, yymsp[-5].minor.yy164, 0, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pList = pList;
  yygotominor.yy164 = sqlite3Expr(TK_NOT, yygotominor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-5].minor.yy164->span,&yymsp[0].minor.yy164->span);
}
#line 3267 "parse.c"
        /* No destructor defined for NOT */
        /* No destructor defined for BETWEEN */
        /* No destructor defined for AND */
        break;
      case 219:
#line 659 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_IN, yymsp[-4].minor.yy164, 0, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pList = yymsp[-1].minor.yy232;
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-4].minor.yy164->span,&yymsp[0].minor.yy0);
}
#line 3279 "parse.c"
        /* No destructor defined for IN */
        /* No destructor defined for LP */
        break;
      case 220:
#line 664 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_IN, yymsp[-4].minor.yy164, 0, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pSelect = yymsp[-1].minor.yy375;
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-4].minor.yy164->span,&yymsp[0].minor.yy0);
}
#line 3290 "parse.c"
        /* No destructor defined for IN */
        /* No destructor defined for LP */
        break;
      case 221:
#line 669 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_IN, yymsp[-5].minor.yy164, 0, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pList = yymsp[-1].minor.yy232;
  yygotominor.yy164 = sqlite3Expr(TK_NOT, yygotominor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-5].minor.yy164->span,&yymsp[0].minor.yy0);
}
#line 3302 "parse.c"
        /* No destructor defined for NOT */
        /* No destructor defined for IN */
        /* No destructor defined for LP */
        break;
      case 222:
#line 675 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_IN, yymsp[-5].minor.yy164, 0, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pSelect = yymsp[-1].minor.yy375;
  yygotominor.yy164 = sqlite3Expr(TK_NOT, yygotominor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-5].minor.yy164->span,&yymsp[0].minor.yy0);
}
#line 3315 "parse.c"
        /* No destructor defined for NOT */
        /* No destructor defined for IN */
        /* No destructor defined for LP */
        break;
      case 223:
#line 681 "parse.y"
{
  SrcList *pSrc = sqlite3SrcListAppend(0, &yymsp[-1].minor.yy318, &yymsp[0].minor.yy318);
  yygotominor.yy164 = sqlite3Expr(TK_IN, yymsp[-3].minor.yy164, 0, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pSelect = sqlite3SelectNew(0,pSrc,0,0,0,0,0,-1,0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-3].minor.yy164->span,yymsp[0].minor.yy318.z?&yymsp[0].minor.yy318:&yymsp[-1].minor.yy318);
}
#line 3328 "parse.c"
        /* No destructor defined for IN */
        break;
      case 224:
#line 687 "parse.y"
{
  SrcList *pSrc = sqlite3SrcListAppend(0, &yymsp[-1].minor.yy318, &yymsp[0].minor.yy318);
  yygotominor.yy164 = sqlite3Expr(TK_IN, yymsp[-4].minor.yy164, 0, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pSelect = sqlite3SelectNew(0,pSrc,0,0,0,0,0,-1,0);
  yygotominor.yy164 = sqlite3Expr(TK_NOT, yygotominor.yy164, 0, 0);
  sqlite3ExprSpan(yygotominor.yy164,&yymsp[-4].minor.yy164->span,yymsp[0].minor.yy318.z?&yymsp[0].minor.yy318:&yymsp[-1].minor.yy318);
}
#line 3340 "parse.c"
        /* No destructor defined for NOT */
        /* No destructor defined for IN */
        break;
      case 225:
#line 697 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_CASE, yymsp[-3].minor.yy164, yymsp[-1].minor.yy164, 0);
  if( yygotominor.yy164 ) yygotominor.yy164->pList = yymsp[-2].minor.yy232;
  sqlite3ExprSpan(yygotominor.yy164, &yymsp[-4].minor.yy0, &yymsp[0].minor.yy0);
}
#line 3351 "parse.c"
        break;
      case 226:
#line 704 "parse.y"
{
  yygotominor.yy232 = sqlite3ExprListAppend(yymsp[-4].minor.yy232, yymsp[-2].minor.yy164, 0);
  yygotominor.yy232 = sqlite3ExprListAppend(yygotominor.yy232, yymsp[0].minor.yy164, 0);
}
#line 3359 "parse.c"
        /* No destructor defined for WHEN */
        /* No destructor defined for THEN */
        break;
      case 227:
#line 708 "parse.y"
{
  yygotominor.yy232 = sqlite3ExprListAppend(0, yymsp[-2].minor.yy164, 0);
  yygotominor.yy232 = sqlite3ExprListAppend(yygotominor.yy232, yymsp[0].minor.yy164, 0);
}
#line 3369 "parse.c"
        /* No destructor defined for WHEN */
        /* No destructor defined for THEN */
        break;
      case 228:
#line 713 "parse.y"
{yygotominor.yy164 = yymsp[0].minor.yy164;}
#line 3376 "parse.c"
        /* No destructor defined for ELSE */
        break;
      case 229:
#line 714 "parse.y"
{yygotominor.yy164 = 0;}
#line 3382 "parse.c"
        break;
      case 230:
#line 716 "parse.y"
{yygotominor.yy164 = yymsp[0].minor.yy164;}
#line 3387 "parse.c"
        break;
      case 231:
#line 717 "parse.y"
{yygotominor.yy164 = 0;}
#line 3392 "parse.c"
        break;
      case 232:
#line 725 "parse.y"
{yygotominor.yy232 = sqlite3ExprListAppend(yymsp[-2].minor.yy232,yymsp[0].minor.yy164,0);}
#line 3397 "parse.c"
        /* No destructor defined for COMMA */
        break;
      case 233:
#line 726 "parse.y"
{yygotominor.yy232 = sqlite3ExprListAppend(0,yymsp[0].minor.yy164,0);}
#line 3403 "parse.c"
        break;
      case 234:
#line 727 "parse.y"
{yygotominor.yy164 = yymsp[0].minor.yy164;}
#line 3408 "parse.c"
        break;
      case 235:
#line 728 "parse.y"
{yygotominor.yy164 = 0;}
#line 3413 "parse.c"
        break;
      case 236:
#line 733 "parse.y"
{
  if( yymsp[-10].minor.yy424!=OE_None ) yymsp[-10].minor.yy424 = yymsp[0].minor.yy424;
  if( yymsp[-10].minor.yy424==OE_Default) yymsp[-10].minor.yy424 = OE_Abort;
  sqlite3CreateIndex(pParse, &yymsp[-8].minor.yy318, &yymsp[-7].minor.yy318, sqlite3SrcListAppend(0,&yymsp[-5].minor.yy318,&yymsp[-4].minor.yy318),
      yymsp[-2].minor.yy232, yymsp[-10].minor.yy424, &yymsp[-11].minor.yy0, &yymsp[-1].minor.yy0);
}
#line 3423 "parse.c"
        /* No destructor defined for INDEX */
        /* No destructor defined for ON */
        /* No destructor defined for LP */
        break;
      case 237:
#line 741 "parse.y"
{ yygotominor.yy424 = OE_Abort; }
#line 3431 "parse.c"
        /* No destructor defined for UNIQUE */
        break;
      case 238:
#line 742 "parse.y"
{ yygotominor.yy424 = OE_None; }
#line 3437 "parse.c"
        break;
      case 239:
#line 750 "parse.y"
{yygotominor.yy232 = 0;}
#line 3442 "parse.c"
        break;
      case 240:
#line 751 "parse.y"
{yygotominor.yy232 = yymsp[-1].minor.yy232;}
#line 3447 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        break;
      case 241:
#line 752 "parse.y"
{
  Expr *p = 0;
  if( yymsp[-1].minor.yy318.n>0 ){
    p = sqlite3Expr(TK_COLUMN, 0, 0, 0);
    if( p ) p->pColl = sqlite3LocateCollSeq(pParse, yymsp[-1].minor.yy318.z, yymsp[-1].minor.yy318.n);
  }
  yygotominor.yy232 = sqlite3ExprListAppend(yymsp[-4].minor.yy232, p, &yymsp[-2].minor.yy318);
}
#line 3461 "parse.c"
        /* No destructor defined for COMMA */
        /* No destructor defined for sortorder */
        break;
      case 242:
#line 760 "parse.y"
{
  Expr *p = 0;
  if( yymsp[-1].minor.yy318.n>0 ){
    p = sqlite3Expr(TK_COLUMN, 0, 0, 0);
    if( p ) p->pColl = sqlite3LocateCollSeq(pParse, yymsp[-1].minor.yy318.z, yymsp[-1].minor.yy318.n);
  }
  yygotominor.yy232 = sqlite3ExprListAppend(0, p, &yymsp[-2].minor.yy318);
}
#line 3475 "parse.c"
        /* No destructor defined for sortorder */
        break;
      case 243:
#line 768 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy318;}
#line 3481 "parse.c"
        break;
      case 244:
#line 774 "parse.y"
{
  sqlite3DropIndex(pParse, sqlite3SrcListAppend(0,&yymsp[-1].minor.yy318,&yymsp[0].minor.yy318));
}
#line 3488 "parse.c"
        /* No destructor defined for DROP */
        /* No destructor defined for INDEX */
        break;
      case 245:
#line 780 "parse.y"
{sqlite3Vacuum(pParse,0);}
#line 3495 "parse.c"
        /* No destructor defined for VACUUM */
        break;
      case 246:
#line 781 "parse.y"
{sqlite3Vacuum(pParse,&yymsp[0].minor.yy318);}
#line 3501 "parse.c"
        /* No destructor defined for VACUUM */
        break;
      case 247:
#line 785 "parse.y"
{sqlite3Pragma(pParse,&yymsp[-3].minor.yy318,&yymsp[-2].minor.yy318,&yymsp[0].minor.yy318,0);}
#line 3507 "parse.c"
        /* No destructor defined for PRAGMA */
        /* No destructor defined for EQ */
        break;
      case 248:
#line 786 "parse.y"
{sqlite3Pragma(pParse,&yymsp[-3].minor.yy318,&yymsp[-2].minor.yy318,&yymsp[0].minor.yy0,0);}
#line 3514 "parse.c"
        /* No destructor defined for PRAGMA */
        /* No destructor defined for EQ */
        break;
      case 249:
#line 787 "parse.y"
{sqlite3Pragma(pParse,&yymsp[-3].minor.yy318,&yymsp[-2].minor.yy318,&yymsp[0].minor.yy318,0);}
#line 3521 "parse.c"
        /* No destructor defined for PRAGMA */
        /* No destructor defined for EQ */
        break;
      case 250:
#line 788 "parse.y"
{
  sqlite3Pragma(pParse,&yymsp[-3].minor.yy318,&yymsp[-2].minor.yy318,&yymsp[0].minor.yy318,1);
}
#line 3530 "parse.c"
        /* No destructor defined for PRAGMA */
        /* No destructor defined for EQ */
        break;
      case 251:
#line 791 "parse.y"
{sqlite3Pragma(pParse,&yymsp[-4].minor.yy318,&yymsp[-3].minor.yy318,&yymsp[-1].minor.yy318,0);}
#line 3537 "parse.c"
        /* No destructor defined for PRAGMA */
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        break;
      case 252:
#line 792 "parse.y"
{sqlite3Pragma(pParse,&yymsp[-1].minor.yy318,&yymsp[0].minor.yy318,0,0);}
#line 3545 "parse.c"
        /* No destructor defined for PRAGMA */
        break;
      case 253:
#line 793 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy318;}
#line 3551 "parse.c"
        /* No destructor defined for plus_opt */
        break;
      case 254:
#line 794 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy318;}
#line 3557 "parse.c"
        /* No destructor defined for MINUS */
        break;
      case 255:
#line 795 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy0;}
#line 3563 "parse.c"
        break;
      case 256:
#line 796 "parse.y"
{yygotominor.yy318 = yymsp[0].minor.yy0;}
#line 3568 "parse.c"
        break;
      case 257:
        /* No destructor defined for PLUS */
        break;
      case 258:
        break;
      case 259:
#line 802 "parse.y"
{
  Token all;
  all.z = yymsp[-3].minor.yy318.z;
  all.n = (yymsp[0].minor.yy0.z - yymsp[-3].minor.yy318.z) + yymsp[0].minor.yy0.n;
  sqlite3FinishTrigger(pParse, yymsp[-1].minor.yy353, &all);
}
#line 3583 "parse.c"
        /* No destructor defined for CREATE */
        /* No destructor defined for BEGIN */
        break;
      case 260:
#line 810 "parse.y"
{
  SrcList *pTab = sqlite3SrcListAppend(0, &yymsp[-3].minor.yy318, &yymsp[-2].minor.yy318);
  sqlite3BeginTrigger(pParse, &yymsp[-8].minor.yy318, &yymsp[-7].minor.yy318, yymsp[-6].minor.yy424, yymsp[-5].minor.yy414.a, yymsp[-5].minor.yy414.b, pTab, yymsp[-1].minor.yy424, yymsp[0].minor.yy206, yymsp[-10].minor.yy424);
  yygotominor.yy318 = (yymsp[-7].minor.yy318.n==0?yymsp[-8].minor.yy318:yymsp[-7].minor.yy318);
}
#line 3594 "parse.c"
        /* No destructor defined for TRIGGER */
        /* No destructor defined for ON */
        break;
      case 261:
#line 817 "parse.y"
{ yygotominor.yy424 = TK_BEFORE; }
#line 3601 "parse.c"
        /* No destructor defined for BEFORE */
        break;
      case 262:
#line 818 "parse.y"
{ yygotominor.yy424 = TK_AFTER;  }
#line 3607 "parse.c"
        /* No destructor defined for AFTER */
        break;
      case 263:
#line 819 "parse.y"
{ yygotominor.yy424 = TK_INSTEAD;}
#line 3613 "parse.c"
        /* No destructor defined for INSTEAD */
        /* No destructor defined for OF */
        break;
      case 264:
#line 820 "parse.y"
{ yygotominor.yy424 = TK_BEFORE; }
#line 3620 "parse.c"
        break;
      case 265:
#line 824 "parse.y"
{ yygotominor.yy414.a = TK_DELETE; yygotominor.yy414.b = 0; }
#line 3625 "parse.c"
        /* No destructor defined for DELETE */
        break;
      case 266:
#line 825 "parse.y"
{ yygotominor.yy414.a = TK_INSERT; yygotominor.yy414.b = 0; }
#line 3631 "parse.c"
        /* No destructor defined for INSERT */
        break;
      case 267:
#line 826 "parse.y"
{ yygotominor.yy414.a = TK_UPDATE; yygotominor.yy414.b = 0;}
#line 3637 "parse.c"
        /* No destructor defined for UPDATE */
        break;
      case 268:
#line 827 "parse.y"
{yygotominor.yy414.a = TK_UPDATE; yygotominor.yy414.b = yymsp[0].minor.yy246; }
#line 3643 "parse.c"
        /* No destructor defined for UPDATE */
        /* No destructor defined for OF */
        break;
      case 269:
#line 830 "parse.y"
{ yygotominor.yy424 = TK_ROW; }
#line 3650 "parse.c"
        break;
      case 270:
#line 831 "parse.y"
{ yygotominor.yy424 = TK_ROW; }
#line 3655 "parse.c"
        /* No destructor defined for FOR */
        /* No destructor defined for EACH */
        /* No destructor defined for ROW */
        break;
      case 271:
#line 832 "parse.y"
{ yygotominor.yy424 = TK_STATEMENT; }
#line 3663 "parse.c"
        /* No destructor defined for FOR */
        /* No destructor defined for EACH */
        /* No destructor defined for STATEMENT */
        break;
      case 272:
#line 835 "parse.y"
{ yygotominor.yy206 = 0; }
#line 3671 "parse.c"
        break;
      case 273:
#line 836 "parse.y"
{ yygotominor.yy206 = yymsp[0].minor.yy164; }
#line 3676 "parse.c"
        /* No destructor defined for WHEN */
        break;
      case 274:
#line 840 "parse.y"
{
  yymsp[-2].minor.yy353->pNext = yymsp[0].minor.yy353;
  yygotominor.yy353 = yymsp[-2].minor.yy353;
}
#line 3685 "parse.c"
        /* No destructor defined for SEMI */
        break;
      case 275:
#line 844 "parse.y"
{ yygotominor.yy353 = 0; }
#line 3691 "parse.c"
        break;
      case 276:
#line 850 "parse.y"
{ yygotominor.yy353 = sqlite3TriggerUpdateStep(&yymsp[-3].minor.yy318, yymsp[-1].minor.yy232, yymsp[0].minor.yy164, yymsp[-4].minor.yy424); }
#line 3696 "parse.c"
        /* No destructor defined for UPDATE */
        /* No destructor defined for SET */
        break;
      case 277:
#line 855 "parse.y"
{yygotominor.yy353 = sqlite3TriggerInsertStep(&yymsp[-5].minor.yy318, yymsp[-4].minor.yy246, yymsp[-1].minor.yy232, 0, yymsp[-7].minor.yy424);}
#line 3703 "parse.c"
        /* No destructor defined for INTO */
        /* No destructor defined for VALUES */
        /* No destructor defined for LP */
        /* No destructor defined for RP */
        break;
      case 278:
#line 858 "parse.y"
{yygotominor.yy353 = sqlite3TriggerInsertStep(&yymsp[-2].minor.yy318, yymsp[-1].minor.yy246, 0, yymsp[0].minor.yy375, yymsp[-4].minor.yy424);}
#line 3712 "parse.c"
        /* No destructor defined for INTO */
        break;
      case 279:
#line 862 "parse.y"
{yygotominor.yy353 = sqlite3TriggerDeleteStep(&yymsp[-1].minor.yy318, yymsp[0].minor.yy164);}
#line 3718 "parse.c"
        /* No destructor defined for DELETE */
        /* No destructor defined for FROM */
        break;
      case 280:
#line 865 "parse.y"
{yygotominor.yy353 = sqlite3TriggerSelectStep(yymsp[0].minor.yy375); }
#line 3725 "parse.c"
        break;
      case 281:
#line 868 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_RAISE, 0, 0, 0); 
  yygotominor.yy164->iColumn = OE_Ignore;
  sqlite3ExprSpan(yygotominor.yy164, &yymsp[-3].minor.yy0, &yymsp[0].minor.yy0);
}
#line 3734 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for IGNORE */
        break;
      case 282:
#line 873 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_RAISE, 0, 0, &yymsp[-1].minor.yy318); 
  yygotominor.yy164->iColumn = OE_Rollback;
  sqlite3ExprSpan(yygotominor.yy164, &yymsp[-5].minor.yy0, &yymsp[0].minor.yy0);
}
#line 3745 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for ROLLBACK */
        /* No destructor defined for COMMA */
        break;
      case 283:
#line 878 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_RAISE, 0, 0, &yymsp[-1].minor.yy318); 
  yygotominor.yy164->iColumn = OE_Abort;
  sqlite3ExprSpan(yygotominor.yy164, &yymsp[-5].minor.yy0, &yymsp[0].minor.yy0);
}
#line 3757 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for ABORT */
        /* No destructor defined for COMMA */
        break;
      case 284:
#line 883 "parse.y"
{
  yygotominor.yy164 = sqlite3Expr(TK_RAISE, 0, 0, &yymsp[-1].minor.yy318); 
  yygotominor.yy164->iColumn = OE_Fail;
  sqlite3ExprSpan(yygotominor.yy164, &yymsp[-5].minor.yy0, &yymsp[0].minor.yy0);
}
#line 3769 "parse.c"
        /* No destructor defined for LP */
        /* No destructor defined for FAIL */
        /* No destructor defined for COMMA */
        break;
      case 285:
#line 890 "parse.y"
{
  sqlite3DropTrigger(pParse,sqlite3SrcListAppend(0,&yymsp[-1].minor.yy318,&yymsp[0].minor.yy318));
}
#line 3779 "parse.c"
        /* No destructor defined for DROP */
        /* No destructor defined for TRIGGER */
        break;
      case 286:
#line 895 "parse.y"
{
  sqlite3Attach(pParse, &yymsp[-3].minor.yy318, &yymsp[-1].minor.yy318, &yymsp[0].minor.yy318);
}
#line 3788 "parse.c"
        /* No destructor defined for ATTACH */
        /* No destructor defined for database_kw_opt */
        /* No destructor defined for AS */
        break;
      case 287:
#line 899 "parse.y"
{ yygotominor.yy318 = yymsp[0].minor.yy318; }
#line 3796 "parse.c"
        /* No destructor defined for USING */
        break;
      case 288:
#line 900 "parse.y"
{ yygotominor.yy318.z = 0; yygotominor.yy318.n = 0; }
#line 3802 "parse.c"
        break;
      case 289:
        /* No destructor defined for DATABASE */
        break;
      case 290:
        break;
      case 291:
#line 906 "parse.y"
{
  sqlite3Detach(pParse, &yymsp[0].minor.yy318);
}
#line 3814 "parse.c"
        /* No destructor defined for DETACH */
        /* No destructor defined for database_kw_opt */
        break;
  };
  yygoto = yyRuleInfo[yyruleno].lhs;
  yysize = yyRuleInfo[yyruleno].nrhs;
  yypParser->yyidx -= yysize;
  yyact = yy_find_reduce_action(yypParser,yygoto);
  if( yyact < YYNSTATE ){
    yy_shift(yypParser,yyact,yygoto,&yygotominor);
  }else if( yyact == YYNSTATE + YYNRULE + 1 ){
    yy_accept(yypParser);
  }
}

/*
** The following code executes when the parse fails
*/
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  sqlite3ParserARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
  sqlite3ParserARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  YYMINORTYPE yyminor            /* The minor type of the error token */
){
  sqlite3ParserARG_FETCH;
#define TOKEN (yyminor.yy0)
#line 23 "parse.y"

  if( pParse->zErrMsg==0 ){
    if( TOKEN.z[0] ){
      sqlite3ErrorMsg(pParse, "near \"%T\": syntax error", &TOKEN);
    }else{
      sqlite3ErrorMsg(pParse, "incomplete SQL statement");
    }
  }

#line 3868 "parse.c"
  sqlite3ParserARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  sqlite3ParserARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
  sqlite3ParserARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "sqlite3ParserAlloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void sqlite3Parser(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  sqlite3ParserTOKENTYPE yyminor       /* The value for the token */
  sqlite3ParserARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  int yyact;            /* The parser action. */
  int yyendofinput;     /* True if we are at the end of input */
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
  yyParser *yypParser;  /* The parser */

  /* (re)initialize the parser, if necessary */
  yypParser = (yyParser*)yyp;
  if( yypParser->yyidx<0 ){
    if( yymajor==0 ) return;
    yypParser->yyidx = 0;
    yypParser->yyerrcnt = -1;
    yypParser->yystack[0].stateno = 0;
    yypParser->yystack[0].major = 0;
  }
  yyminorunion.yy0 = yyminor;
  yyendofinput = (yymajor==0);
  sqlite3ParserARG_STORE;

#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sInput %s\n",yyTracePrompt,yyTokenName[yymajor]);
  }
#endif

  do{
    yyact = yy_find_shift_action(yypParser,yymajor);
    if( yyact<YYNSTATE ){
      yy_shift(yypParser,yyact,yymajor,&yyminorunion);
      yypParser->yyerrcnt--;
      if( yyendofinput && yypParser->yyidx>=0 ){
        yymajor = 0;
      }else{
        yymajor = YYNOCODE;
      }
    }else if( yyact < YYNSTATE + YYNRULE ){
      yy_reduce(yypParser,yyact-YYNSTATE);
    }else if( yyact == YY_ERROR_ACTION ){
      int yymx;
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yymx = yypParser->yystack[yypParser->yyidx].major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yymajor,&yyminorunion);
        yymajor = YYNOCODE;
      }else{
         while(
          yypParser->yyidx >= 0 &&
          yymx != YYERRORSYMBOL &&
          (yyact = yy_find_shift_action(yypParser,YYERRORSYMBOL)) >= YYNSTATE
        ){
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yyidx < 0 || yymajor==0 ){
          yy_destructor(yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          YYMINORTYPE u2;
          u2.YYERRSYMDT = 0;
          yy_shift(yypParser,yyact,YYERRORSYMBOL,&u2);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
      }
      yymajor = YYNOCODE;
#endif
    }else{
      yy_accept(yypParser);
      yymajor = YYNOCODE;
    }
  }while( yymajor!=YYNOCODE && yypParser->yyidx>=0 );
  return;
}
